/*
  JWildfireC - an external C-based fractal-flame-renderer for JWildfire 
  Copyright (C) 2012 Andreas Maschke

  This is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser 
  General Public License as published by the Free Software Foundation; either version 2.1 of the 
  License, or (at your option) any later version.
 
  This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License along with this software; 
  if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
#ifndef __JWF_EXAMPLE_FLAMES_H__
#define __JWF_EXAMPLE_FLAMES_H__

#include "jwf_VariationFactory.h"

Flame *createExample1Flame() {
	VariationFactory *variationFactory=new VariationFactory();
  Flame *flame;
  Variation *var;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=827;
  flame->height=465;
  flame->centreX=0.0f;
  flame->centreY=-0.2f;
  flame->pixelsPerUnit=90.4375f;
  flame->camRoll=41.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=3.6f;
  flame->camPitch=0.8377580409572781f * 180.0f / M_PI;
  flame->camYaw=1.9547687622336491f * 180.0f / M_PI;
  flame->camPerspective=0.32f;
  flame->camZ=-1.02f;
  flame->camDOF=0.82f;
  flame->palette->setColor(0,1,2,3);
  flame->palette->setColor(0,158,242,22);
  flame->palette->setColor(1,156,241,27);
  flame->palette->setColor(2,155,240,33);
  flame->palette->setColor(3,153,239,38);
  flame->palette->setColor(4,151,239,43);
  flame->palette->setColor(5,149,238,48);
  flame->palette->setColor(6,148,237,54);
  flame->palette->setColor(7,146,236,59);
  flame->palette->setColor(8,144,235,64);
  flame->palette->setColor(9,142,234,69);
  flame->palette->setColor(10,141,234,75);
  flame->palette->setColor(11,139,233,80);
  flame->palette->setColor(12,137,232,85);
  flame->palette->setColor(13,135,231,91);
  flame->palette->setColor(14,134,230,96);
  flame->palette->setColor(15,132,229,101);
  flame->palette->setColor(16,130,229,106);
  flame->palette->setColor(17,129,228,112);
  flame->palette->setColor(18,127,227,117);
  flame->palette->setColor(19,125,226,122);
  flame->palette->setColor(20,123,225,127);
  flame->palette->setColor(21,122,224,133);
  flame->palette->setColor(22,120,223,138);
  flame->palette->setColor(23,118,223,143);
  flame->palette->setColor(24,116,222,149);
  flame->palette->setColor(25,115,221,154);
  flame->palette->setColor(26,113,220,159);
  flame->palette->setColor(27,111,219,164);
  flame->palette->setColor(28,109,218,170);
  flame->palette->setColor(29,108,218,175);
  flame->palette->setColor(30,106,217,180);
  flame->palette->setColor(31,104,216,185);
  flame->palette->setColor(32,103,215,191);
  flame->palette->setColor(33,101,214,196);
  flame->palette->setColor(34,99,213,201);
  flame->palette->setColor(35,97,212,207);
  flame->palette->setColor(36,96,212,212);
  flame->palette->setColor(37,94,211,217);
  flame->palette->setColor(38,92,210,222);
  flame->palette->setColor(39,90,209,228);
  flame->palette->setColor(40,89,208,233);
  flame->palette->setColor(41,87,207,238);
  flame->palette->setColor(42,85,207,243);
  flame->palette->setColor(43,85,205,247);
  flame->palette->setColor(44,88,201,246);
  flame->palette->setColor(45,91,198,245);
  flame->palette->setColor(46,94,194,244);
  flame->palette->setColor(47,98,191,243);
  flame->palette->setColor(48,101,188,243);
  flame->palette->setColor(49,104,184,242);
  flame->palette->setColor(50,107,181,241);
  flame->palette->setColor(51,110,177,240);
  flame->palette->setColor(52,113,174,239);
  flame->palette->setColor(53,116,170,238);
  flame->palette->setColor(54,120,167,237);
  flame->palette->setColor(55,123,163,237);
  flame->palette->setColor(56,126,160,236);
  flame->palette->setColor(57,129,156,235);
  flame->palette->setColor(58,132,153,234);
  flame->palette->setColor(59,135,149,233);
  flame->palette->setColor(60,138,146,232);
  flame->palette->setColor(61,142,142,232);
  flame->palette->setColor(62,145,139,231);
  flame->palette->setColor(63,148,135,230);
  flame->palette->setColor(64,151,132,229);
  flame->palette->setColor(65,154,129,228);
  flame->palette->setColor(66,157,125,227);
  flame->palette->setColor(67,160,122,226);
  flame->palette->setColor(68,164,118,226);
  flame->palette->setColor(69,167,115,225);
  flame->palette->setColor(70,170,111,224);
  flame->palette->setColor(71,173,108,223);
  flame->palette->setColor(72,176,104,222);
  flame->palette->setColor(73,179,101,221);
  flame->palette->setColor(74,182,97,221);
  flame->palette->setColor(75,186,94,220);
  flame->palette->setColor(76,189,90,219);
  flame->palette->setColor(77,192,87,218);
  flame->palette->setColor(78,195,83,217);
  flame->palette->setColor(79,198,80,216);
  flame->palette->setColor(80,201,77,216);
  flame->palette->setColor(81,204,73,215);
  flame->palette->setColor(82,208,70,214);
  flame->palette->setColor(83,211,66,213);
  flame->palette->setColor(84,214,63,212);
  flame->palette->setColor(85,217,59,211);
  flame->palette->setColor(86,218,60,208);
  flame->palette->setColor(87,219,63,203);
  flame->palette->setColor(88,220,66,198);
  flame->palette->setColor(89,220,68,193);
  flame->palette->setColor(90,221,71,189);
  flame->palette->setColor(91,221,74,184);
  flame->palette->setColor(92,222,77,179);
  flame->palette->setColor(93,222,80,174);
  flame->palette->setColor(94,223,83,169);
  flame->palette->setColor(95,223,85,165);
  flame->palette->setColor(96,224,88,160);
  flame->palette->setColor(97,225,91,155);
  flame->palette->setColor(98,225,94,150);
  flame->palette->setColor(99,226,97,145);
  flame->palette->setColor(100,226,100,141);
  flame->palette->setColor(101,227,102,136);
  flame->palette->setColor(102,227,105,131);
  flame->palette->setColor(103,228,108,126);
  flame->palette->setColor(104,229,111,121);
  flame->palette->setColor(105,229,114,117);
  flame->palette->setColor(106,230,117,112);
  flame->palette->setColor(107,230,119,107);
  flame->palette->setColor(108,231,122,102);
  flame->palette->setColor(109,231,125,97);
  flame->palette->setColor(110,232,128,92);
  flame->palette->setColor(111,232,131,88);
  flame->palette->setColor(112,233,134,83);
  flame->palette->setColor(113,234,136,78);
  flame->palette->setColor(114,234,139,73);
  flame->palette->setColor(115,235,142,68);
  flame->palette->setColor(116,235,145,64);
  flame->palette->setColor(117,236,148,59);
  flame->palette->setColor(118,236,151,54);
  flame->palette->setColor(119,237,153,49);
  flame->palette->setColor(120,238,156,44);
  flame->palette->setColor(121,238,159,40);
  flame->palette->setColor(122,239,162,35);
  flame->palette->setColor(123,239,165,30);
  flame->palette->setColor(124,240,168,25);
  flame->palette->setColor(125,240,170,20);
  flame->palette->setColor(126,241,173,16);
  flame->palette->setColor(127,241,176,11);
  flame->palette->setColor(128,242,179,6);
  flame->palette->setColor(129,238,175,11);
  flame->palette->setColor(130,234,172,16);
  flame->palette->setColor(131,231,168,20);
  flame->palette->setColor(132,227,164,25);
  flame->palette->setColor(133,223,160,30);
  flame->palette->setColor(134,219,157,35);
  flame->palette->setColor(135,216,153,39);
  flame->palette->setColor(136,212,149,44);
  flame->palette->setColor(137,208,146,49);
  flame->palette->setColor(138,204,142,54);
  flame->palette->setColor(139,200,138,58);
  flame->palette->setColor(140,197,135,63);
  flame->palette->setColor(141,193,131,68);
  flame->palette->setColor(142,189,127,73);
  flame->palette->setColor(143,185,123,77);
  flame->palette->setColor(144,182,120,82);
  flame->palette->setColor(145,178,116,87);
  flame->palette->setColor(146,174,112,92);
  flame->palette->setColor(147,170,109,96);
  flame->palette->setColor(148,167,105,101);
  flame->palette->setColor(149,163,101,106);
  flame->palette->setColor(150,159,98,111);
  flame->palette->setColor(151,155,94,115);
  flame->palette->setColor(152,151,90,120);
  flame->palette->setColor(153,148,86,125);
  flame->palette->setColor(154,144,83,130);
  flame->palette->setColor(155,140,79,134);
  flame->palette->setColor(156,136,75,139);
  flame->palette->setColor(157,133,72,144);
  flame->palette->setColor(158,129,68,149);
  flame->palette->setColor(159,125,64,153);
  flame->palette->setColor(160,121,61,158);
  flame->palette->setColor(161,117,57,163);
  flame->palette->setColor(162,114,53,168);
  flame->palette->setColor(163,110,49,173);
  flame->palette->setColor(164,106,46,177);
  flame->palette->setColor(165,102,42,182);
  flame->palette->setColor(166,99,38,187);
  flame->palette->setColor(167,95,35,192);
  flame->palette->setColor(168,91,31,196);
  flame->palette->setColor(169,87,27,201);
  flame->palette->setColor(170,84,23,206);
  flame->palette->setColor(171,81,22,209);
  flame->palette->setColor(172,82,25,208);
  flame->palette->setColor(173,82,27,206);
  flame->palette->setColor(174,82,30,205);
  flame->palette->setColor(175,83,32,204);
  flame->palette->setColor(176,83,35,203);
  flame->palette->setColor(177,84,38,202);
  flame->palette->setColor(178,84,40,201);
  flame->palette->setColor(179,85,43,200);
  flame->palette->setColor(180,85,46,199);
  flame->palette->setColor(181,86,48,197);
  flame->palette->setColor(182,86,51,196);
  flame->palette->setColor(183,86,53,195);
  flame->palette->setColor(184,87,56,194);
  flame->palette->setColor(185,87,59,193);
  flame->palette->setColor(186,88,61,192);
  flame->palette->setColor(187,88,64,191);
  flame->palette->setColor(188,89,67,190);
  flame->palette->setColor(189,89,69,188);
  flame->palette->setColor(190,90,72,187);
  flame->palette->setColor(191,90,74,186);
  flame->palette->setColor(192,91,77,185);
  flame->palette->setColor(193,91,80,184);
  flame->palette->setColor(194,91,82,183);
  flame->palette->setColor(195,92,85,182);
  flame->palette->setColor(196,92,88,181);
  flame->palette->setColor(197,93,90,179);
  flame->palette->setColor(198,93,93,178);
  flame->palette->setColor(199,94,95,177);
  flame->palette->setColor(200,94,98,176);
  flame->palette->setColor(201,95,101,175);
  flame->palette->setColor(202,95,103,174);
  flame->palette->setColor(203,95,106,173);
  flame->palette->setColor(204,96,109,172);
  flame->palette->setColor(205,96,111,170);
  flame->palette->setColor(206,97,114,169);
  flame->palette->setColor(207,97,116,168);
  flame->palette->setColor(208,98,119,167);
  flame->palette->setColor(209,98,122,166);
  flame->palette->setColor(210,99,124,165);
  flame->palette->setColor(211,99,127,164);
  flame->palette->setColor(212,99,130,163);
  flame->palette->setColor(213,100,132,161);
  flame->palette->setColor(214,100,131,159);
  flame->palette->setColor(215,101,129,156);
  flame->palette->setColor(216,102,127,153);
  flame->palette->setColor(217,103,124,150);
  flame->palette->setColor(218,103,122,147);
  flame->palette->setColor(219,104,119,144);
  flame->palette->setColor(220,105,117,141);
  flame->palette->setColor(221,105,114,138);
  flame->palette->setColor(222,106,112,135);
  flame->palette->setColor(223,107,109,132);
  flame->palette->setColor(224,108,107,130);
  flame->palette->setColor(225,108,105,127);
  flame->palette->setColor(226,109,102,124);
  flame->palette->setColor(227,110,100,121);
  flame->palette->setColor(228,110,97,118);
  flame->palette->setColor(229,111,95,115);
  flame->palette->setColor(230,112,92,112);
  flame->palette->setColor(231,112,90,109);
  flame->palette->setColor(232,113,88,106);
  flame->palette->setColor(233,114,85,103);
  flame->palette->setColor(234,115,83,100);
  flame->palette->setColor(235,115,80,97);
  flame->palette->setColor(236,116,78,94);
  flame->palette->setColor(237,117,75,91);
  flame->palette->setColor(238,117,73,88);
  flame->palette->setColor(239,118,70,85);
  flame->palette->setColor(240,119,68,82);
  flame->palette->setColor(241,119,66,79);
  flame->palette->setColor(242,120,63,76);
  flame->palette->setColor(243,121,61,73);
  flame->palette->setColor(244,122,58,70);
  flame->palette->setColor(245,122,56,67);
  flame->palette->setColor(246,123,53,65);
  flame->palette->setColor(247,124,51,62);
  flame->palette->setColor(248,124,49,59);
  flame->palette->setColor(249,125,46,56);
  flame->palette->setColor(250,126,44,53);
  flame->palette->setColor(251,126,41,50);
  flame->palette->setColor(252,127,39,47);
  flame->palette->setColor(253,128,36,44);
  flame->palette->setColor(254,129,34,41);
  flame->palette->setColor(255,129,31,38);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=4.89f;
  flame->xForms[0]->color=0.5365080234038873f;
  flame->xForms[0]->colorSymmetry=0.955582179465092f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=-1.0f;
  flame->xForms[0]->coeff10=1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->addVariation(variationFactory->newInstance("spherical3D"), 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=2.84f;
  flame->xForms[1]->color=0.31649810202925777f;
  flame->xForms[1]->colorSymmetry=0.916646015535179f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=-1.0f;
  flame->xForms[1]->coeff10=1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->addVariation(variationFactory->newInstance("spherical3D"), 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.5f;
  flame->xForms[2]->color=0.5830445359820691f;
  flame->xForms[2]->colorSymmetry=-1.0f;
  flame->xForms[2]->coeff00=1.0f;
  flame->xForms[2]->coeff01=0.0f;
  flame->xForms[2]->coeff10=0.0f;
  flame->xForms[2]->coeff11=1.0f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=5.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new ZTranslateFunc(), 0.30433094687885565f);
  flame->xForms[2]->addVariation(new PreBlurFunc(), 0.26563369879032617f);
  flame->xForms[2]->addVariation(new CylinderFunc(), 0.11891887474062209f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.5f;
  flame->xForms[3]->color=0.6856941117815826f;
  flame->xForms[3]->colorSymmetry=-1.0f;
  flame->xForms[3]->coeff00=1.0f;
  flame->xForms[3]->coeff01=0.0f;
  flame->xForms[3]->coeff10=0.0f;
  flame->xForms[3]->coeff11=1.0f;
  flame->xForms[3]->coeff20=0.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=3.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new ZTranslateFunc(), 0.20639813794469436f);
  var=flame->xForms[3]->addVariation(new RadialBlurFunc(), 0.19263776620364423f);
  flame->xForms[3]->addVariation(new PreBlurFunc(), 0.03007267870484459f);
  var->setParameter("angle",0.5f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.1f;
  flame->xForms[4]->color=0.9037075940648581f;
  flame->xForms[4]->colorSymmetry=-1.0f;
  flame->xForms[4]->coeff00=1.0f;
  flame->xForms[4]->coeff01=0.0f;
  flame->xForms[4]->coeff10=0.0f;
  flame->xForms[4]->coeff11=1.0f;
  flame->xForms[4]->coeff20=0.0f;
  flame->xForms[4]->coeff21=0.0f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.3f;
  flame->xForms[4]->postCoeff21=0.0f;
  flame->xForms[4]->addVariation(new GaussianBlurFunc(), 0.009961222159546684f);
  flame->xForms[4]->addVariation(new ZTranslateFunc(), 0.00581856475425525f);
  // final xForm
  hostMalloc((void**)&flame->finalXForm, sizeof(XForm));
  flame->finalXForm->init();
  flame->finalXForm->coeff00=0.7071067811865476f;
  flame->finalXForm->coeff01=-0.7071067811865475f;
  flame->finalXForm->coeff10=0.7071067811865475f;
  flame->finalXForm->coeff11=0.7071067811865476f;
  flame->finalXForm->coeff20=0.0f;
  flame->finalXForm->coeff21=0.25f;
  flame->finalXForm->postCoeff00=1.0f;
  flame->finalXForm->postCoeff01=0.0f;
  flame->finalXForm->postCoeff10=0.0f;
  flame->finalXForm->postCoeff11=1.0f;
  flame->finalXForm->postCoeff20=0.3f;
  flame->finalXForm->postCoeff21=-0.25f;
  flame->finalXForm->addVariation(new Linear3DFunc(), 0.9591442592460886f);
  /*
  FlameTransformationContext *ctx=createHostFlameTransformationContext(flame);
  flame->prepareFlame(ctx);
  freeHostFlameTransformationContext(ctx);
  */
  return flame;
}

Flame *createExample2Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=768;
  flame->height=432;
  flame->centreX=0.0f;
  flame->centreY=0.0f;
  flame->pixelsPerUnit=84.0f;
  flame->camRoll=90.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=2.4f;
  flame->camPitch=0.0f;
  flame->camYaw=0.0;
  flame->camPerspective=0.32f;
  flame->camZ=0.0f;
  flame->camDOF=0.0f;

  flame->palette->setColor(0,2,236,182);
  flame->palette->setColor(1,14,235,184);
  flame->palette->setColor(2,26,234,187);
  flame->palette->setColor(3,38,233,189);
  flame->palette->setColor(4,50,233,191);
  flame->palette->setColor(5,62,232,193);
  flame->palette->setColor(6,74,231,196);
  flame->palette->setColor(7,86,230,198);
  flame->palette->setColor(8,99,229,200);
  flame->palette->setColor(9,111,228,202);
  flame->palette->setColor(10,123,227,205);
  flame->palette->setColor(11,135,226,207);
  flame->palette->setColor(12,147,226,209);
  flame->palette->setColor(13,159,225,211);
  flame->palette->setColor(14,171,224,214);
  flame->palette->setColor(15,183,223,216);
  flame->palette->setColor(16,195,222,218);
  flame->palette->setColor(17,187,215,220);
  flame->palette->setColor(18,179,207,221);
  flame->palette->setColor(19,171,200,223);
  flame->palette->setColor(20,164,192,224);
  flame->palette->setColor(21,156,185,226);
  flame->palette->setColor(22,148,177,227);
  flame->palette->setColor(23,140,170,229);
  flame->palette->setColor(24,132,163,231);
  flame->palette->setColor(25,124,155,232);
  flame->palette->setColor(26,116,148,234);
  flame->palette->setColor(27,108,140,235);
  flame->palette->setColor(28,101,133,237);
  flame->palette->setColor(29,93,125,238);
  flame->palette->setColor(30,85,118,240);
  flame->palette->setColor(31,77,110,241);
  flame->palette->setColor(32,69,103,243);
  flame->palette->setColor(33,67,112,230);
  flame->palette->setColor(34,65,121,216);
  flame->palette->setColor(35,63,130,203);
  flame->palette->setColor(36,62,139,189);
  flame->palette->setColor(37,60,148,176);
  flame->palette->setColor(38,58,157,162);
  flame->palette->setColor(39,56,166,149);
  flame->palette->setColor(40,54,176,135);
  flame->palette->setColor(41,52,185,122);
  flame->palette->setColor(42,50,194,108);
  flame->palette->setColor(43,48,203,95);
  flame->palette->setColor(44,47,212,81);
  flame->palette->setColor(45,45,221,68);
  flame->palette->setColor(46,43,230,54);
  flame->palette->setColor(47,41,239,41);
  flame->palette->setColor(48,39,248,27);
  flame->palette->setColor(49,48,234,39);
  flame->palette->setColor(50,58,220,50);
  flame->palette->setColor(51,67,206,62);
  flame->palette->setColor(52,76,193,73);
  flame->palette->setColor(53,86,179,85);
  flame->palette->setColor(54,95,165,96);
  flame->palette->setColor(55,104,151,108);
  flame->palette->setColor(56,114,137,120);
  flame->palette->setColor(57,123,123,131);
  flame->palette->setColor(58,132,109,143);
  flame->palette->setColor(59,141,95,154);
  flame->palette->setColor(60,151,82,166);
  flame->palette->setColor(61,160,68,177);
  flame->palette->setColor(62,169,54,189);
  flame->palette->setColor(63,179,40,200);
  flame->palette->setColor(64,188,26,212);
  flame->palette->setColor(65,176,34,211);
  flame->palette->setColor(66,165,42,211);
  flame->palette->setColor(67,153,50,210);
  flame->palette->setColor(68,142,58,209);
  flame->palette->setColor(69,130,65,209);
  flame->palette->setColor(70,119,73,208);
  flame->palette->setColor(71,107,81,207);
  flame->palette->setColor(72,96,89,207);
  flame->palette->setColor(73,84,97,206);
  flame->palette->setColor(74,72,105,205);
  flame->palette->setColor(75,61,113,204);
  flame->palette->setColor(76,49,121,204);
  flame->palette->setColor(77,38,128,203);
  flame->palette->setColor(78,26,136,202);
  flame->palette->setColor(79,15,144,202);
  flame->palette->setColor(80,3,152,201);
  flame->palette->setColor(81,16,152,190);
  flame->palette->setColor(82,28,152,180);
  flame->palette->setColor(83,41,152,169);
  flame->palette->setColor(84,53,153,159);
  flame->palette->setColor(85,66,153,148);
  flame->palette->setColor(86,78,153,137);
  flame->palette->setColor(87,91,153,127);
  flame->palette->setColor(88,104,153,116);
  flame->palette->setColor(89,116,153,105);
  flame->palette->setColor(90,129,153,95);
  flame->palette->setColor(91,141,153,84);
  flame->palette->setColor(92,154,154,74);
  flame->palette->setColor(93,166,154,63);
  flame->palette->setColor(94,179,154,52);
  flame->palette->setColor(95,191,154,42);
  flame->palette->setColor(96,204,154,31);
  flame->palette->setColor(97,206,160,30);
  flame->palette->setColor(98,207,167,28);
  flame->palette->setColor(99,209,173,27);
  flame->palette->setColor(100,210,179,25);
  flame->palette->setColor(101,212,185,24);
  flame->palette->setColor(102,213,192,22);
  flame->palette->setColor(103,215,198,21);
  flame->palette->setColor(104,217,204,20);
  flame->palette->setColor(105,218,210,18);
  flame->palette->setColor(106,220,217,17);
  flame->palette->setColor(107,221,223,15);
  flame->palette->setColor(108,223,229,14);
  flame->palette->setColor(109,224,235,12);
  flame->palette->setColor(110,226,242,11);
  flame->palette->setColor(111,227,248,9);
  flame->palette->setColor(112,229,254,8);
  flame->palette->setColor(113,215,250,20);
  flame->palette->setColor(114,202,246,32);
  flame->palette->setColor(115,188,242,43);
  flame->palette->setColor(116,174,238,55);
  flame->palette->setColor(117,160,234,67);
  flame->palette->setColor(118,147,230,79);
  flame->palette->setColor(119,133,226,90);
  flame->palette->setColor(120,119,222,102);
  flame->palette->setColor(121,105,218,114);
  flame->palette->setColor(122,92,214,126);
  flame->palette->setColor(123,78,210,137);
  flame->palette->setColor(124,64,206,149);
  flame->palette->setColor(125,50,202,161);
  flame->palette->setColor(126,37,198,173);
  flame->palette->setColor(127,23,194,184);
  flame->palette->setColor(128,9,190,196);
  flame->palette->setColor(129,14,193,186);
  flame->palette->setColor(130,19,197,176);
  flame->palette->setColor(131,24,200,166);
  flame->palette->setColor(132,30,204,156);
  flame->palette->setColor(133,35,207,146);
  flame->palette->setColor(134,40,211,136);
  flame->palette->setColor(135,45,214,126);
  flame->palette->setColor(136,50,218,116);
  flame->palette->setColor(137,55,221,105);
  flame->palette->setColor(138,60,224,95);
  flame->palette->setColor(139,65,228,85);
  flame->palette->setColor(140,71,231,75);
  flame->palette->setColor(141,76,235,65);
  flame->palette->setColor(142,81,238,55);
  flame->palette->setColor(143,86,242,45);
  flame->palette->setColor(144,91,245,35);
  flame->palette->setColor(145,99,243,48);
  flame->palette->setColor(146,107,241,62);
  flame->palette->setColor(147,115,239,75);
  flame->palette->setColor(148,124,237,88);
  flame->palette->setColor(149,132,235,101);
  flame->palette->setColor(150,140,233,115);
  flame->palette->setColor(151,148,231,128);
  flame->palette->setColor(152,156,229,141);
  flame->palette->setColor(153,164,227,154);
  flame->palette->setColor(154,172,225,168);
  flame->palette->setColor(155,180,223,181);
  flame->palette->setColor(156,189,221,194);
  flame->palette->setColor(157,197,219,207);
  flame->palette->setColor(158,205,217,221);
  flame->palette->setColor(159,213,215,234);
  flame->palette->setColor(160,221,213,247);
  flame->palette->setColor(161,208,206,239);
  flame->palette->setColor(162,195,199,232);
  flame->palette->setColor(163,182,191,224);
  flame->palette->setColor(164,169,184,216);
  flame->palette->setColor(165,156,177,209);
  flame->palette->setColor(166,143,170,201);
  flame->palette->setColor(167,130,163,193);
  flame->palette->setColor(168,118,156,186);
  flame->palette->setColor(169,105,148,178);
  flame->palette->setColor(170,92,141,170);
  flame->palette->setColor(171,79,134,162);
  flame->palette->setColor(172,66,127,155);
  flame->palette->setColor(173,53,120,147);
  flame->palette->setColor(174,40,112,139);
  flame->palette->setColor(175,27,105,132);
  flame->palette->setColor(176,14,98,124);
  flame->palette->setColor(177,23,93,126);
  flame->palette->setColor(178,32,88,127);
  flame->palette->setColor(179,42,84,129);
  flame->palette->setColor(180,51,79,130);
  flame->palette->setColor(181,60,74,132);
  flame->palette->setColor(182,69,69,133);
  flame->palette->setColor(183,78,64,135);
  flame->palette->setColor(184,88,60,137);
  flame->palette->setColor(185,97,55,138);
  flame->palette->setColor(186,106,50,140);
  flame->palette->setColor(187,115,45,141);
  flame->palette->setColor(188,124,40,143);
  flame->palette->setColor(189,133,35,144);
  flame->palette->setColor(190,143,31,146);
  flame->palette->setColor(191,152,26,147);
  flame->palette->setColor(192,161,21,149);
  flame->palette->setColor(193,152,28,149);
  flame->palette->setColor(194,144,35,150);
  flame->palette->setColor(195,135,42,150);
  flame->palette->setColor(196,126,49,150);
  flame->palette->setColor(197,117,56,150);
  flame->palette->setColor(198,109,63,151);
  flame->palette->setColor(199,100,70,151);
  flame->palette->setColor(200,91,77,151);
  flame->palette->setColor(201,82,84,151);
  flame->palette->setColor(202,74,91,152);
  flame->palette->setColor(203,65,98,152);
  flame->palette->setColor(204,56,105,152);
  flame->palette->setColor(205,47,112,152);
  flame->palette->setColor(206,39,119,153);
  flame->palette->setColor(207,30,126,153);
  flame->palette->setColor(208,21,133,153);
  flame->palette->setColor(209,31,136,147);
  flame->palette->setColor(210,42,138,142);
  flame->palette->setColor(211,52,141,136);
  flame->palette->setColor(212,63,144,131);
  flame->palette->setColor(213,73,146,125);
  flame->palette->setColor(214,83,149,119);
  flame->palette->setColor(215,94,151,114);
  flame->palette->setColor(216,104,154,108);
  flame->palette->setColor(217,114,157,102);
  flame->palette->setColor(218,125,159,97);
  flame->palette->setColor(219,135,162,91);
  flame->palette->setColor(220,146,165,86);
  flame->palette->setColor(221,156,167,80);
  flame->palette->setColor(222,166,170,74);
  flame->palette->setColor(223,177,172,69);
  flame->palette->setColor(224,187,175,63);
  flame->palette->setColor(225,178,169,68);
  flame->palette->setColor(226,170,164,73);
  flame->palette->setColor(227,161,158,79);
  flame->palette->setColor(228,153,152,84);
  flame->palette->setColor(229,144,147,89);
  flame->palette->setColor(230,136,141,94);
  flame->palette->setColor(231,127,135,99);
  flame->palette->setColor(232,119,130,105);
  flame->palette->setColor(233,110,124,110);
  flame->palette->setColor(234,101,118,115);
  flame->palette->setColor(235,93,112,120);
  flame->palette->setColor(236,84,107,125);
  flame->palette->setColor(237,76,101,130);
  flame->palette->setColor(238,67,95,136);
  flame->palette->setColor(239,59,90,141);
  flame->palette->setColor(240,50,84,146);
  flame->palette->setColor(241,58,88,141);
  flame->palette->setColor(242,66,91,137);
  flame->palette->setColor(243,74,95,132);
  flame->palette->setColor(244,82,99,127);
  flame->palette->setColor(245,89,102,122);
  flame->palette->setColor(246,97,106,118);
  flame->palette->setColor(247,105,109,113);
  flame->palette->setColor(248,113,113,108);
  flame->palette->setColor(249,121,117,103);
  flame->palette->setColor(250,129,120,99);
  flame->palette->setColor(251,137,124,94);
  flame->palette->setColor(252,145,128,89);
  flame->palette->setColor(253,152,131,84);
  flame->palette->setColor(254,160,135,80);
  flame->palette->setColor(255,168,138,75);

  flame->xFormCount=4;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=14.17f;
  flame->xForms[0]->color=0.6698f;
  flame->xForms[0]->colorSymmetry=1.0f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=-1.0f;
  flame->xForms[0]->coeff10=1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=6.31f;
  flame->xForms[1]->color=0.01687f;
  flame->xForms[1]->colorSymmetry=1.0f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=1.0f;
  flame->xForms[1]->coeff10=-1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.47879f;
  flame->xForms[2]->color=0.16125f;
  flame->xForms[2]->colorSymmetry=0.0f;
  flame->xForms[2]->coeff00=0.0f;
  flame->xForms[2]->coeff01=-1.0f;
  flame->xForms[2]->coeff10=1.0f;
  flame->xForms[2]->coeff11=0.0f;
  flame->xForms[2]->coeff20=3.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new Linear3DFunc(), 1.0f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.31854f;
  flame->xForms[3]->color=0.56949f;
  flame->xForms[3]->colorSymmetry=0.0f;
  flame->xForms[3]->coeff00=0.0f;
  flame->xForms[3]->coeff01=-1.0f;
  flame->xForms[3]->coeff10=1.0f;
  flame->xForms[3]->coeff11=0.0f;
  flame->xForms[3]->coeff20=-3.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=1.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new Linear3DFunc(), 1.0f);

  return flame;
}

Flame *createExample3Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=768;
  flame->height=432;
  flame->centreX=-0.75f;
  flame->centreY=-0.7f;
  flame->pixelsPerUnit=113.0f;
  flame->camRoll=-20.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=1.0f;
  flame->camPitch=0.0f;
  flame->camYaw=0.0;
  flame->camPerspective=0.0f;
  flame->camZ=0.0f;
  flame->camDOF=0.0f;

  flame->palette->setColor(0,117,112,61);
  flame->palette->setColor(1,116,118,69);
  flame->palette->setColor(2,115,125,78);
  flame->palette->setColor(3,113,132,86);
  flame->palette->setColor(4,112,139,94);
  flame->palette->setColor(5,111,146,103);
  flame->palette->setColor(6,110,152,111);
  flame->palette->setColor(7,109,159,120);
  flame->palette->setColor(8,108,166,128);
  flame->palette->setColor(9,107,173,136);
  flame->palette->setColor(10,106,180,145);
  flame->palette->setColor(11,105,186,153);
  flame->palette->setColor(12,104,193,162);
  flame->palette->setColor(13,103,200,170);
  flame->palette->setColor(14,102,207,178);
  flame->palette->setColor(15,101,214,187);
  flame->palette->setColor(16,100,220,195);
  flame->palette->setColor(17,99,227,204);
  flame->palette->setColor(18,98,234,212);
  flame->palette->setColor(19,96,236,215);
  flame->palette->setColor(20,92,230,210);
  flame->palette->setColor(21,89,224,205);
  flame->palette->setColor(22,85,218,200);
  flame->palette->setColor(23,82,212,195);
  flame->palette->setColor(24,78,206,190);
  flame->palette->setColor(25,75,200,185);
  flame->palette->setColor(26,71,194,180);
  flame->palette->setColor(27,68,188,175);
  flame->palette->setColor(28,64,182,170);
  flame->palette->setColor(29,61,176,165);
  flame->palette->setColor(30,57,170,160);
  flame->palette->setColor(31,54,164,155);
  flame->palette->setColor(32,50,158,150);
  flame->palette->setColor(33,47,152,145);
  flame->palette->setColor(34,43,146,140);
  flame->palette->setColor(35,40,140,135);
  flame->palette->setColor(36,37,134,130);
  flame->palette->setColor(37,33,128,125);
  flame->palette->setColor(38,30,122,120);
  flame->palette->setColor(39,26,116,115);
  flame->palette->setColor(40,23,110,110);
  flame->palette->setColor(41,19,104,105);
  flame->palette->setColor(42,16,98,100);
  flame->palette->setColor(43,12,92,95);
  flame->palette->setColor(44,9,86,90);
  flame->palette->setColor(45,12,89,88);
  flame->palette->setColor(46,16,94,88);
  flame->palette->setColor(47,20,99,87);
  flame->palette->setColor(48,25,104,86);
  flame->palette->setColor(49,29,109,85);
  flame->palette->setColor(50,34,114,84);
  flame->palette->setColor(51,38,118,83);
  flame->palette->setColor(52,42,123,83);
  flame->palette->setColor(53,47,128,82);
  flame->palette->setColor(54,51,133,81);
  flame->palette->setColor(55,56,138,80);
  flame->palette->setColor(56,60,143,79);
  flame->palette->setColor(57,65,148,79);
  flame->palette->setColor(58,69,153,78);
  flame->palette->setColor(59,73,158,77);
  flame->palette->setColor(60,78,163,76);
  flame->palette->setColor(61,82,168,75);
  flame->palette->setColor(62,87,173,74);
  flame->palette->setColor(63,91,178,74);
  flame->palette->setColor(64,95,182,73);
  flame->palette->setColor(65,100,187,72);
  flame->palette->setColor(66,104,192,71);
  flame->palette->setColor(67,109,197,70);
  flame->palette->setColor(68,113,202,69);
  flame->palette->setColor(69,117,207,69);
  flame->palette->setColor(70,122,209,68);
  flame->palette->setColor(71,125,202,69);
  flame->palette->setColor(72,128,194,70);
  flame->palette->setColor(73,131,187,70);
  flame->palette->setColor(74,134,179,71);
  flame->palette->setColor(75,137,172,72);
  flame->palette->setColor(76,140,164,72);
  flame->palette->setColor(77,143,156,73);
  flame->palette->setColor(78,146,149,74);
  flame->palette->setColor(79,149,141,74);
  flame->palette->setColor(80,152,134,75);
  flame->palette->setColor(81,155,126,76);
  flame->palette->setColor(82,158,119,77);
  flame->palette->setColor(83,161,111,77);
  flame->palette->setColor(84,164,103,78);
  flame->palette->setColor(85,167,96,79);
  flame->palette->setColor(86,170,88,79);
  flame->palette->setColor(87,173,81,80);
  flame->palette->setColor(88,176,73,81);
  flame->palette->setColor(89,180,66,82);
  flame->palette->setColor(90,183,58,82);
  flame->palette->setColor(91,186,50,83);
  flame->palette->setColor(92,189,43,84);
  flame->palette->setColor(93,192,35,84);
  flame->palette->setColor(94,195,28,85);
  flame->palette->setColor(95,198,20,86);
  flame->palette->setColor(96,196,21,85);
  flame->palette->setColor(97,192,29,83);
  flame->palette->setColor(98,187,36,81);
  flame->palette->setColor(99,182,44,78);
  flame->palette->setColor(100,178,51,76);
  flame->palette->setColor(101,173,58,74);
  flame->palette->setColor(102,169,66,72);
  flame->palette->setColor(103,164,73,70);
  flame->palette->setColor(104,159,80,68);
  flame->palette->setColor(105,155,88,66);
  flame->palette->setColor(106,150,95,64);
  flame->palette->setColor(107,146,103,62);
  flame->palette->setColor(108,141,110,59);
  flame->palette->setColor(109,136,117,57);
  flame->palette->setColor(110,132,125,55);
  flame->palette->setColor(111,127,132,53);
  flame->palette->setColor(112,122,140,51);
  flame->palette->setColor(113,118,147,49);
  flame->palette->setColor(114,113,154,47);
  flame->palette->setColor(115,109,162,45);
  flame->palette->setColor(116,104,169,43);
  flame->palette->setColor(117,99,176,40);
  flame->palette->setColor(118,95,184,38);
  flame->palette->setColor(119,90,191,36);
  flame->palette->setColor(120,86,199,34);
  flame->palette->setColor(121,81,206,32);
  flame->palette->setColor(122,87,201,40);
  flame->palette->setColor(123,93,196,47);
  flame->palette->setColor(124,99,191,55);
  flame->palette->setColor(125,104,186,63);
  flame->palette->setColor(126,110,181,71);
  flame->palette->setColor(127,116,176,78);
  flame->palette->setColor(128,122,171,86);
  flame->palette->setColor(129,128,166,94);
  flame->palette->setColor(130,134,161,102);
  flame->palette->setColor(131,140,156,109);
  flame->palette->setColor(132,145,151,117);
  flame->palette->setColor(133,151,146,125);
  flame->palette->setColor(134,157,140,133);
  flame->palette->setColor(135,163,135,140);
  flame->palette->setColor(136,169,130,148);
  flame->palette->setColor(137,175,125,156);
  flame->palette->setColor(138,181,120,163);
  flame->palette->setColor(139,186,115,171);
  flame->palette->setColor(140,192,110,179);
  flame->palette->setColor(141,198,105,187);
  flame->palette->setColor(142,204,100,194);
  flame->palette->setColor(143,210,95,202);
  flame->palette->setColor(144,216,90,210);
  flame->palette->setColor(145,222,85,218);
  flame->palette->setColor(146,227,80,225);
  flame->palette->setColor(147,229,79,228);
  flame->palette->setColor(148,224,84,224);
  flame->palette->setColor(149,219,88,219);
  flame->palette->setColor(150,214,93,214);
  flame->palette->setColor(151,209,98,210);
  flame->palette->setColor(152,204,103,205);
  flame->palette->setColor(153,199,107,201);
  flame->palette->setColor(154,193,112,196);
  flame->palette->setColor(155,188,117,191);
  flame->palette->setColor(156,183,121,187);
  flame->palette->setColor(157,178,126,182);
  flame->palette->setColor(158,173,131,177);
  flame->palette->setColor(159,168,136,173);
  flame->palette->setColor(160,163,140,168);
  flame->palette->setColor(161,158,145,164);
  flame->palette->setColor(162,153,150,159);
  flame->palette->setColor(163,148,155,154);
  flame->palette->setColor(164,143,159,150);
  flame->palette->setColor(165,138,164,145);
  flame->palette->setColor(166,132,169,141);
  flame->palette->setColor(167,127,173,136);
  flame->palette->setColor(168,122,178,131);
  flame->palette->setColor(169,117,183,127);
  flame->palette->setColor(170,112,188,122);
  flame->palette->setColor(171,107,192,118);
  flame->palette->setColor(172,102,197,113);
  flame->palette->setColor(173,105,196,112);
  flame->palette->setColor(174,110,193,112);
  flame->palette->setColor(175,115,191,112);
  flame->palette->setColor(176,120,188,112);
  flame->palette->setColor(177,126,185,112);
  flame->palette->setColor(178,131,183,112);
  flame->palette->setColor(179,136,180,112);
  flame->palette->setColor(180,141,177,112);
  flame->palette->setColor(181,146,175,112);
  flame->palette->setColor(182,151,172,112);
  flame->palette->setColor(183,156,169,112);
  flame->palette->setColor(184,161,167,112);
  flame->palette->setColor(185,167,164,112);
  flame->palette->setColor(186,172,161,111);
  flame->palette->setColor(187,177,159,111);
  flame->palette->setColor(188,182,156,111);
  flame->palette->setColor(189,187,153,111);
  flame->palette->setColor(190,192,151,111);
  flame->palette->setColor(191,197,148,111);
  flame->palette->setColor(192,202,145,111);
  flame->palette->setColor(193,207,143,111);
  flame->palette->setColor(194,213,140,111);
  flame->palette->setColor(195,218,137,111);
  flame->palette->setColor(196,223,135,111);
  flame->palette->setColor(197,228,132,111);
  flame->palette->setColor(198,232,129,110);
  flame->palette->setColor(199,231,125,108);
  flame->palette->setColor(200,230,120,105);
  flame->palette->setColor(201,229,116,102);
  flame->palette->setColor(202,228,111,99);
  flame->palette->setColor(203,228,107,96);
  flame->palette->setColor(204,227,102,94);
  flame->palette->setColor(205,226,98,91);
  flame->palette->setColor(206,225,93,88);
  flame->palette->setColor(207,224,89,85);
  flame->palette->setColor(208,223,84,82);
  flame->palette->setColor(209,222,80,80);
  flame->palette->setColor(210,222,75,77);
  flame->palette->setColor(211,221,71,74);
  flame->palette->setColor(212,220,66,71);
  flame->palette->setColor(213,219,62,68);
  flame->palette->setColor(214,218,57,65);
  flame->palette->setColor(215,217,53,63);
  flame->palette->setColor(216,216,48,60);
  flame->palette->setColor(217,216,44,57);
  flame->palette->setColor(218,215,39,54);
  flame->palette->setColor(219,214,35,51);
  flame->palette->setColor(220,213,30,49);
  flame->palette->setColor(221,212,26,46);
  flame->palette->setColor(222,211,21,43);
  flame->palette->setColor(223,210,17,40);
  flame->palette->setColor(224,206,18,43);
  flame->palette->setColor(225,200,22,49);
  flame->palette->setColor(226,194,26,56);
  flame->palette->setColor(227,187,30,62);
  flame->palette->setColor(228,181,34,69);
  flame->palette->setColor(229,175,39,75);
  flame->palette->setColor(230,168,43,82);
  flame->palette->setColor(231,162,47,88);
  flame->palette->setColor(232,156,51,94);
  flame->palette->setColor(233,150,56,101);
  flame->palette->setColor(234,143,60,107);
  flame->palette->setColor(235,137,64,114);
  flame->palette->setColor(236,131,68,120);
  flame->palette->setColor(237,124,72,127);
  flame->palette->setColor(238,118,77,133);
  flame->palette->setColor(239,112,81,140);
  flame->palette->setColor(240,106,85,146);
  flame->palette->setColor(241,99,89,152);
  flame->palette->setColor(242,93,93,159);
  flame->palette->setColor(243,87,98,165);
  flame->palette->setColor(244,80,102,172);
  flame->palette->setColor(245,74,106,178);
  flame->palette->setColor(246,68,110,185);
  flame->palette->setColor(247,62,115,191);
  flame->palette->setColor(248,55,119,198);
  flame->palette->setColor(249,124,64,2);
  flame->palette->setColor(250,123,71,10);
  flame->palette->setColor(251,122,78,19);
  flame->palette->setColor(252,121,84,27);
  flame->palette->setColor(253,120,91,36);
  flame->palette->setColor(254,119,98,44);
  flame->palette->setColor(255,118,105,52);

  flame->xFormCount=3;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=43.07f;
  flame->xForms[0]->color=0.9f;
  flame->xForms[0]->colorSymmetry=0.75469f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=0.995f;
  flame->xForms[0]->coeff10=-0.995f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=-1.42f;
  flame->xForms[0]->coeff21=0.08734f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  {
    Variation *var=flame->xForms[0]->addVariation(new Waves2Func(), 1.0f);
    var->setParameter("scalex",0.043f);
    var->setParameter("scaley",-0.04252f);
    var->setParameter("freqx",3.11f);
    var->setParameter("freqy",3.37f);
  }
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=0.5f;
  flame->xForms[1]->color=0.0f;
  flame->xForms[1]->colorSymmetry=-1.0f;
  flame->xForms[1]->coeff00=1.0f;
  flame->xForms[1]->coeff01=0.0f;
  flame->xForms[1]->coeff10=0.0f;
  flame->xForms[1]->coeff11=1.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new BubbleFunc(), 0.98386f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.5f;
  flame->xForms[2]->color=0.0f;
  flame->xForms[2]->colorSymmetry=-1.0f;
  flame->xForms[2]->coeff00=-0.77336f;
  flame->xForms[2]->coeff01=0.63397f;
  flame->xForms[2]->coeff10=-0.63397f;
  flame->xForms[2]->coeff11=-0.77336f;
  flame->xForms[2]->coeff20=1.2f;
  flame->xForms[2]->coeff21=0.00779822f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new Linear3DFunc(), 1.0f);

  return flame;
}

Flame *createExample4Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=780;
  flame->height=439;
  flame->centreX=-0.245f;
  flame->centreY=-0.049f;
  flame->pixelsPerUnit=197.35f;
  flame->camRoll=0.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=800.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=1.9f;
  flame->camPitch=-159.0f;
  flame->camYaw=97.0;
  flame->camPerspective=0.41f;
  flame->camZ=0.0f;
  flame->camDOF=0.0f;

  flame->palette->setColor(0,100,76,17);
  flame->palette->setColor(1,102,75,18);
  flame->palette->setColor(2,103,73,20);
  flame->palette->setColor(3,105,72,21);
  flame->palette->setColor(4,107,70,23);
  flame->palette->setColor(5,108,69,24);
  flame->palette->setColor(6,110,67,26);
  flame->palette->setColor(7,111,66,27);
  flame->palette->setColor(8,113,64,29);
  flame->palette->setColor(9,115,63,30);
  flame->palette->setColor(10,116,61,32);
  flame->palette->setColor(11,118,60,33);
  flame->palette->setColor(12,120,58,34);
  flame->palette->setColor(13,121,57,36);
  flame->palette->setColor(14,123,55,37);
  flame->palette->setColor(15,125,54,39);
  flame->palette->setColor(16,126,52,40);
  flame->palette->setColor(17,128,51,42);
  flame->palette->setColor(18,130,49,43);
  flame->palette->setColor(19,131,48,45);
  flame->palette->setColor(20,133,46,46);
  flame->palette->setColor(21,134,45,48);
  flame->palette->setColor(22,136,44,49);
  flame->palette->setColor(23,138,42,50);
  flame->palette->setColor(24,139,41,52);
  flame->palette->setColor(25,141,39,53);
  flame->palette->setColor(26,143,38,55);
  flame->palette->setColor(27,144,36,56);
  flame->palette->setColor(28,146,35,58);
  flame->palette->setColor(29,148,33,59);
  flame->palette->setColor(30,149,32,61);
  flame->palette->setColor(31,151,30,62);
  flame->palette->setColor(32,153,29,64);
  flame->palette->setColor(33,154,27,65);
  flame->palette->setColor(34,156,26,66);
  flame->palette->setColor(35,157,24,68);
  flame->palette->setColor(36,159,23,69);
  flame->palette->setColor(37,161,21,71);
  flame->palette->setColor(38,162,20,72);
  flame->palette->setColor(39,164,18,74);
  flame->palette->setColor(40,166,17,75);
  flame->palette->setColor(41,167,15,77);
  flame->palette->setColor(42,169,14,78);
  flame->palette->setColor(43,170,14,78);
  flame->palette->setColor(44,170,16,77);
  flame->palette->setColor(45,170,18,75);
  flame->palette->setColor(46,170,20,73);
  flame->palette->setColor(47,171,22,71);
  flame->palette->setColor(48,171,24,70);
  flame->palette->setColor(49,171,26,68);
  flame->palette->setColor(50,171,28,66);
  flame->palette->setColor(51,171,30,64);
  flame->palette->setColor(52,171,32,63);
  flame->palette->setColor(53,171,34,61);
  flame->palette->setColor(54,172,36,59);
  flame->palette->setColor(55,172,38,57);
  flame->palette->setColor(56,172,40,56);
  flame->palette->setColor(57,172,42,54);
  flame->palette->setColor(58,172,44,52);
  flame->palette->setColor(59,172,46,50);
  flame->palette->setColor(60,172,48,49);
  flame->palette->setColor(61,173,50,47);
  flame->palette->setColor(62,173,52,45);
  flame->palette->setColor(63,173,54,43);
  flame->palette->setColor(64,173,56,42);
  flame->palette->setColor(65,173,58,40);
  flame->palette->setColor(66,173,60,38);
  flame->palette->setColor(67,173,62,36);
  flame->palette->setColor(68,174,64,34);
  flame->palette->setColor(69,174,66,33);
  flame->palette->setColor(70,174,68,31);
  flame->palette->setColor(71,174,70,29);
  flame->palette->setColor(72,174,72,27);
  flame->palette->setColor(73,174,74,26);
  flame->palette->setColor(74,174,76,24);
  flame->palette->setColor(75,175,78,22);
  flame->palette->setColor(76,175,80,20);
  flame->palette->setColor(77,175,82,19);
  flame->palette->setColor(78,175,84,17);
  flame->palette->setColor(79,175,86,15);
  flame->palette->setColor(80,175,88,13);
  flame->palette->setColor(81,175,90,12);
  flame->palette->setColor(82,176,92,10);
  flame->palette->setColor(83,176,94,8);
  flame->palette->setColor(84,176,96,6);
  flame->palette->setColor(85,176,98,5);
  flame->palette->setColor(86,176,99,5);
  flame->palette->setColor(87,175,98,6);
  flame->palette->setColor(88,175,97,7);
  flame->palette->setColor(89,174,97,9);
  flame->palette->setColor(90,173,96,10);
  flame->palette->setColor(91,173,95,11);
  flame->palette->setColor(92,172,95,12);
  flame->palette->setColor(93,172,94,14);
  flame->palette->setColor(94,171,94,15);
  flame->palette->setColor(95,171,93,16);
  flame->palette->setColor(96,170,92,17);
  flame->palette->setColor(97,169,92,18);
  flame->palette->setColor(98,169,91,20);
  flame->palette->setColor(99,168,90,21);
  flame->palette->setColor(100,168,90,22);
  flame->palette->setColor(101,167,89,23);
  flame->palette->setColor(102,167,88,25);
  flame->palette->setColor(103,166,88,26);
  flame->palette->setColor(104,166,87,27);
  flame->palette->setColor(105,165,87,28);
  flame->palette->setColor(106,164,86,30);
  flame->palette->setColor(107,164,85,31);
  flame->palette->setColor(108,163,85,32);
  flame->palette->setColor(109,163,84,33);
  flame->palette->setColor(110,162,83,35);
  flame->palette->setColor(111,162,83,36);
  flame->palette->setColor(112,161,82,37);
  flame->palette->setColor(113,160,81,38);
  flame->palette->setColor(114,160,81,40);
  flame->palette->setColor(115,159,80,41);
  flame->palette->setColor(116,159,80,42);
  flame->palette->setColor(117,158,79,43);
  flame->palette->setColor(118,158,78,45);
  flame->palette->setColor(119,157,78,46);
  flame->palette->setColor(120,157,77,47);
  flame->palette->setColor(121,156,76,48);
  flame->palette->setColor(122,155,76,50);
  flame->palette->setColor(123,155,75,51);
  flame->palette->setColor(124,154,75,52);
  flame->palette->setColor(125,154,74,53);
  flame->palette->setColor(126,153,73,55);
  flame->palette->setColor(127,153,73,56);
  flame->palette->setColor(128,152,72,57);
  flame->palette->setColor(129,153,72,60);
  flame->palette->setColor(130,154,72,63);
  flame->palette->setColor(131,156,72,66);
  flame->palette->setColor(132,157,73,70);
  flame->palette->setColor(133,158,73,73);
  flame->palette->setColor(134,159,73,76);
  flame->palette->setColor(135,161,73,79);
  flame->palette->setColor(136,162,73,82);
  flame->palette->setColor(137,163,73,85);
  flame->palette->setColor(138,164,73,89);
  flame->palette->setColor(139,165,74,92);
  flame->palette->setColor(140,167,74,95);
  flame->palette->setColor(141,168,74,98);
  flame->palette->setColor(142,169,74,101);
  flame->palette->setColor(143,170,74,104);
  flame->palette->setColor(144,172,74,108);
  flame->palette->setColor(145,173,74,111);
  flame->palette->setColor(146,174,75,114);
  flame->palette->setColor(147,175,75,117);
  flame->palette->setColor(148,176,75,120);
  flame->palette->setColor(149,178,75,123);
  flame->palette->setColor(150,179,75,127);
  flame->palette->setColor(151,180,75,130);
  flame->palette->setColor(152,181,75,133);
  flame->palette->setColor(153,182,76,136);
  flame->palette->setColor(154,184,76,139);
  flame->palette->setColor(155,185,76,142);
  flame->palette->setColor(156,186,76,146);
  flame->palette->setColor(157,187,76,149);
  flame->palette->setColor(158,189,76,152);
  flame->palette->setColor(159,190,76,155);
  flame->palette->setColor(160,191,77,158);
  flame->palette->setColor(161,192,77,161);
  flame->palette->setColor(162,193,77,165);
  flame->palette->setColor(163,195,77,168);
  flame->palette->setColor(164,196,77,171);
  flame->palette->setColor(165,197,77,174);
  flame->palette->setColor(166,198,77,177);
  flame->palette->setColor(167,200,77,180);
  flame->palette->setColor(168,201,78,184);
  flame->palette->setColor(169,202,78,187);
  flame->palette->setColor(170,203,78,190);
  flame->palette->setColor(171,204,79,192);
  flame->palette->setColor(172,204,82,192);
  flame->palette->setColor(173,204,85,193);
  flame->palette->setColor(174,205,88,193);
  flame->palette->setColor(175,205,91,193);
  flame->palette->setColor(176,205,94,194);
  flame->palette->setColor(177,205,97,194);
  flame->palette->setColor(178,205,100,194);
  flame->palette->setColor(179,206,103,194);
  flame->palette->setColor(180,206,106,195);
  flame->palette->setColor(181,206,109,195);
  flame->palette->setColor(182,206,111,195);
  flame->palette->setColor(183,206,114,195);
  flame->palette->setColor(184,207,117,196);
  flame->palette->setColor(185,207,120,196);
  flame->palette->setColor(186,207,123,196);
  flame->palette->setColor(187,207,126,197);
  flame->palette->setColor(188,207,129,197);
  flame->palette->setColor(189,207,132,197);
  flame->palette->setColor(190,208,135,197);
  flame->palette->setColor(191,208,138,198);
  flame->palette->setColor(192,208,141,198);
  flame->palette->setColor(193,208,144,198);
  flame->palette->setColor(194,208,147,199);
  flame->palette->setColor(195,209,150,199);
  flame->palette->setColor(196,209,153,199);
  flame->palette->setColor(197,209,156,199);
  flame->palette->setColor(198,209,159,200);
  flame->palette->setColor(199,209,162,200);
  flame->palette->setColor(200,210,165,200);
  flame->palette->setColor(201,210,168,201);
  flame->palette->setColor(202,210,171,201);
  flame->palette->setColor(203,210,173,201);
  flame->palette->setColor(204,210,176,201);
  flame->palette->setColor(205,210,179,202);
  flame->palette->setColor(206,211,182,202);
  flame->palette->setColor(207,211,185,202);
  flame->palette->setColor(208,211,188,203);
  flame->palette->setColor(209,211,191,203);
  flame->palette->setColor(210,211,194,203);
  flame->palette->setColor(211,212,197,203);
  flame->palette->setColor(212,212,200,204);
  flame->palette->setColor(213,212,203,204);
  flame->palette->setColor(214,211,201,201);
  flame->palette->setColor(215,209,197,196);
  flame->palette->setColor(216,208,193,192);
  flame->palette->setColor(217,206,189,187);
  flame->palette->setColor(218,205,185,183);
  flame->palette->setColor(219,203,181,178);
  flame->palette->setColor(220,202,177,173);
  flame->palette->setColor(221,200,173,169);
  flame->palette->setColor(222,199,169,164);
  flame->palette->setColor(223,197,165,160);
  flame->palette->setColor(224,196,162,155);
  flame->palette->setColor(225,194,158,150);
  flame->palette->setColor(226,192,154,146);
  flame->palette->setColor(227,191,150,141);
  flame->palette->setColor(228,189,146,137);
  flame->palette->setColor(229,188,142,132);
  flame->palette->setColor(230,186,138,127);
  flame->palette->setColor(231,185,134,123);
  flame->palette->setColor(232,183,130,118);
  flame->palette->setColor(233,182,126,114);
  flame->palette->setColor(234,180,122,109);
  flame->palette->setColor(235,178,118,104);
  flame->palette->setColor(236,177,114,100);
  flame->palette->setColor(237,175,110,95);
  flame->palette->setColor(238,174,106,91);
  flame->palette->setColor(239,172,102,86);
  flame->palette->setColor(240,171,98,82);
  flame->palette->setColor(241,169,94,77);
  flame->palette->setColor(242,168,90,72);
  flame->palette->setColor(243,166,86,68);
  flame->palette->setColor(244,165,82,63);
  flame->palette->setColor(245,163,78,59);
  flame->palette->setColor(246,161,74,54);
  flame->palette->setColor(247,160,70,49);
  flame->palette->setColor(248,158,66,45);
  flame->palette->setColor(249,157,62,40);
  flame->palette->setColor(250,155,58,36);
  flame->palette->setColor(251,154,54,31);
  flame->palette->setColor(252,152,50,26);
  flame->palette->setColor(253,151,46,22);
  flame->palette->setColor(254,149,42,17);
  flame->palette->setColor(255,148,38,13);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=1.36f;
  flame->xForms[0]->color=0.98449f;
  flame->xForms[0]->colorSymmetry=0.94686f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=-1.0f;
  flame->xForms[0]->coeff10=1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=2.34f;
  flame->xForms[1]->color=0.86427f;
  flame->xForms[1]->colorSymmetry=0.93241f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=-1.0f;
  flame->xForms[1]->coeff10=1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.5f;
  flame->xForms[2]->color=0.09072f;
  flame->xForms[2]->colorSymmetry=-1.0f;
  flame->xForms[2]->coeff00=1.0f;
  flame->xForms[2]->coeff01=0.0f;
  flame->xForms[2]->coeff10=0.0f;
  flame->xForms[2]->coeff11=1.0f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=5.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new ZTranslateFunc(), 0.24535f);
  flame->xForms[2]->addVariation(new CylinderFunc(), 0.06954f);
  flame->xForms[2]->addVariation(new PreBlurFunc(), 0.27362f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.5f;
  flame->xForms[3]->color=0.74116f;
  flame->xForms[3]->colorSymmetry=-1.0f;
  flame->xForms[3]->coeff00=1.0f;
  flame->xForms[3]->coeff01=0.0f;
  flame->xForms[3]->coeff10=0.0f;
  flame->xForms[3]->coeff11=1.0f;
  flame->xForms[3]->coeff20=0.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=3.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new ZTranslateFunc(), 0.3493f);
  flame->xForms[3]->addVariation(new CylinderFunc(), 0.06923f);
  flame->xForms[3]->addVariation(new PreBlurFunc(), 0.02801f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.1f;
  flame->xForms[4]->color=0.36248f;
  flame->xForms[4]->colorSymmetry=-1.0f;
  flame->xForms[4]->coeff00=1.0f;
  flame->xForms[4]->coeff01=0.0f;
  flame->xForms[4]->coeff10=0.0f;
  flame->xForms[4]->coeff11=1.0f;
  flame->xForms[4]->coeff20=0.0f;
  flame->xForms[4]->coeff21=0.0f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.3f;
  flame->xForms[4]->postCoeff21=0.0f;
  flame->xForms[4]->addVariation(new ZTranslateFunc(), 0.0060525f);
  flame->xForms[4]->addVariation(new GaussianBlurFunc(), 0.00582289f);
  // final xForm
  hostMalloc((void**)&flame->finalXForm, sizeof(XForm));
  flame->finalXForm->init();
  flame->finalXForm->weight=0.1f;
  flame->finalXForm->color=1.0f;
  flame->finalXForm->colorSymmetry=0.98061f;
  flame->finalXForm->coeff00=0.70711f;
  flame->finalXForm->coeff01=-0.70711f;
  flame->finalXForm->coeff10=0.70711f;
  flame->finalXForm->coeff11=0.70711f;
  flame->finalXForm->coeff20=0.62847f;
  flame->finalXForm->coeff21=-0.17944f;
  flame->finalXForm->postCoeff00=1.0f;
  flame->finalXForm->postCoeff01=0.0f;
  flame->finalXForm->postCoeff10=0.0f;
  flame->finalXForm->postCoeff11=1.0f;
  flame->finalXForm->postCoeff20=0.0f;
  flame->finalXForm->postCoeff21=-0.25f;
  flame->finalXForm->addVariation(new EllipticFunc(), 0.77651f);
  flame->finalXForm->addVariation(new CrossFunc(), -1.7f);

  return flame;
}

Flame *createExample5Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=894;
  flame->height=503;
  flame->centreX=-0.5f;
  flame->centreY=-0.05f;
  flame->pixelsPerUnit=243.79f;
  flame->camRoll=90.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=6.76f;
  flame->gamma=1.86f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=1.0f;
  flame->camPitch=-11.0f;
  flame->camYaw=0.0;
  flame->camPerspective=0.32f;
  flame->camZ=0.0f;
  flame->camDOF=0.0f;

  flame->palette->setColor(0,88,3,9);
  flame->palette->setColor(1,64,0,9);
  flame->palette->setColor(2,44,3,9);
  flame->palette->setColor(3,24,4,9);
  flame->palette->setColor(4,15,0,9);
  flame->palette->setColor(5,16,4,9);
  flame->palette->setColor(6,28,8,9);
  flame->palette->setColor(7,40,4,9);
  flame->palette->setColor(8,48,3,0);
  flame->palette->setColor(9,52,0,0);
  flame->palette->setColor(10,52,0,0);
  flame->palette->setColor(11,48,0,0);
  flame->palette->setColor(12,40,0,0);
  flame->palette->setColor(13,28,4,0);
  flame->palette->setColor(14,16,0,0);
  flame->palette->setColor(15,8,0,9);
  flame->palette->setColor(16,8,0,9);
  flame->palette->setColor(17,15,0,9);
  flame->palette->setColor(18,28,0,0);
  flame->palette->setColor(19,40,0,0);
  flame->palette->setColor(20,44,0,0);
  flame->palette->setColor(21,48,0,0);
  flame->palette->setColor(22,56,4,0);
  flame->palette->setColor(23,56,3,0);
  flame->palette->setColor(24,52,0,0);
  flame->palette->setColor(25,48,0,0);
  flame->palette->setColor(26,40,0,0);
  flame->palette->setColor(27,28,0,0);
  flame->palette->setColor(28,16,0,0);
  flame->palette->setColor(29,4,0,0);
  flame->palette->setColor(30,0,0,0);
  flame->palette->setColor(31,0,0,0);
  flame->palette->setColor(32,0,0,0);
  flame->palette->setColor(33,0,0,0);
  flame->palette->setColor(34,0,0,0);
  flame->palette->setColor(35,0,4,0);
  flame->palette->setColor(36,0,4,0);
  flame->palette->setColor(37,0,0,0);
  flame->palette->setColor(38,0,0,0);
  flame->palette->setColor(39,0,0,0);
  flame->palette->setColor(40,4,0,0);
  flame->palette->setColor(41,8,4,0);
  flame->palette->setColor(42,12,4,0);
  flame->palette->setColor(43,24,4,0);
  flame->palette->setColor(44,32,4,0);
  flame->palette->setColor(45,40,4,9);
  flame->palette->setColor(46,48,4,9);
  flame->palette->setColor(47,52,3,9);
  flame->palette->setColor(48,68,3,9);
  flame->palette->setColor(49,81,4,0);
  flame->palette->setColor(50,101,3,0);
  flame->palette->setColor(51,117,0,0);
  flame->palette->setColor(52,137,0,9);
  flame->palette->setColor(53,158,0,9);
  flame->palette->setColor(54,182,0,9);
  flame->palette->setColor(55,202,7,0);
  flame->palette->setColor(56,210,10,0);
  flame->palette->setColor(57,202,7,0);
  flame->palette->setColor(58,190,0,9);
  flame->palette->setColor(59,174,0,9);
  flame->palette->setColor(60,145,3,9);
  flame->palette->setColor(61,113,3,0);
  flame->palette->setColor(62,89,3,0);
  flame->palette->setColor(63,68,3,9);
  flame->palette->setColor(64,48,7,9);
  flame->palette->setColor(65,36,4,9);
  flame->palette->setColor(66,20,0,0);
  flame->palette->setColor(67,8,0,0);
  flame->palette->setColor(68,4,0,0);
  flame->palette->setColor(69,4,0,0);
  flame->palette->setColor(70,4,0,0);
  flame->palette->setColor(71,8,4,0);
  flame->palette->setColor(72,24,4,0);
  flame->palette->setColor(73,40,4,0);
  flame->palette->setColor(74,60,3,0);
  flame->palette->setColor(75,84,3,0);
  flame->palette->setColor(76,109,3,0);
  flame->palette->setColor(77,125,3,0);
  flame->palette->setColor(78,145,0,0);
  flame->palette->setColor(79,158,0,0);
  flame->palette->setColor(80,162,0,0);
  flame->palette->setColor(81,162,0,0);
  flame->palette->setColor(82,162,0,0);
  flame->palette->setColor(83,162,0,0);
  flame->palette->setColor(84,162,3,0);
  flame->palette->setColor(85,153,7,9);
  flame->palette->setColor(86,157,11,0);
  flame->palette->setColor(87,153,0,0);
  flame->palette->setColor(88,145,3,0);
  flame->palette->setColor(89,129,0,0);
  flame->palette->setColor(90,109,0,0);
  flame->palette->setColor(91,89,0,0);
  flame->palette->setColor(92,73,3,0);
  flame->palette->setColor(93,52,3,0);
  flame->palette->setColor(94,36,4,0);
  flame->palette->setColor(95,16,0,0);
  flame->palette->setColor(96,8,0,0);
  flame->palette->setColor(97,4,0,0);
  flame->palette->setColor(98,0,0,0);
  flame->palette->setColor(99,0,0,0);
  flame->palette->setColor(100,0,0,0);
  flame->palette->setColor(101,0,0,0);
  flame->palette->setColor(102,0,0,0);
  flame->palette->setColor(103,0,0,0);
  flame->palette->setColor(104,0,0,0);
  flame->palette->setColor(105,0,0,0);
  flame->palette->setColor(106,0,0,9);
  flame->palette->setColor(107,4,0,9);
  flame->palette->setColor(108,0,0,9);
  flame->palette->setColor(109,0,0,9);
  flame->palette->setColor(110,0,0,9);
  flame->palette->setColor(111,0,0,0);
  flame->palette->setColor(112,0,0,0);
  flame->palette->setColor(113,0,0,0);
  flame->palette->setColor(114,0,0,0);
  flame->palette->setColor(115,0,0,0);
  flame->palette->setColor(116,0,0,0);
  flame->palette->setColor(117,0,4,0);
  flame->palette->setColor(118,0,4,0);
  flame->palette->setColor(119,0,0,0);
  flame->palette->setColor(120,0,0,0);
  flame->palette->setColor(121,0,0,0);
  flame->palette->setColor(122,0,0,0);
  flame->palette->setColor(123,4,0,0);
  flame->palette->setColor(124,16,0,0);
  flame->palette->setColor(125,40,4,0);
  flame->palette->setColor(126,60,0,0);
  flame->palette->setColor(127,73,0,0);
  flame->palette->setColor(128,97,0,0);
  flame->palette->setColor(129,113,0,0);
  flame->palette->setColor(130,133,0,0);
  flame->palette->setColor(131,157,0,0);
  flame->palette->setColor(132,166,7,0);
  flame->palette->setColor(133,182,7,0);
  flame->palette->setColor(134,174,10,0);
  flame->palette->setColor(135,174,15,9);
  flame->palette->setColor(136,166,29,0);
  flame->palette->setColor(137,157,35,9);
  flame->palette->setColor(138,121,30,9);
  flame->palette->setColor(139,93,15,9);
  flame->palette->setColor(140,93,11,9);
  flame->palette->setColor(141,92,11,0);
  flame->palette->setColor(142,89,3,9);
  flame->palette->setColor(143,88,3,9);
  flame->palette->setColor(144,80,3,9);
  flame->palette->setColor(145,76,0,0);
  flame->palette->setColor(146,68,0,0);
  flame->palette->setColor(147,64,3,0);
  flame->palette->setColor(148,68,3,0);
  flame->palette->setColor(149,76,0,0);
  flame->palette->setColor(150,89,3,0);
  flame->palette->setColor(151,105,0,0);
  flame->palette->setColor(152,121,0,0);
  flame->palette->setColor(153,145,0,0);
  flame->palette->setColor(154,158,0,0);
  flame->palette->setColor(155,162,3,0);
  flame->palette->setColor(156,153,18,9);
  flame->palette->setColor(157,169,7,0);
  flame->palette->setColor(158,166,0,0);
  flame->palette->setColor(159,174,3,0);
  flame->palette->setColor(160,174,0,0);
  flame->palette->setColor(161,178,0,0);
  flame->palette->setColor(162,178,3,0);
  flame->palette->setColor(163,182,3,0);
  flame->palette->setColor(164,190,11,9);
  flame->palette->setColor(165,206,14,9);
  flame->palette->setColor(166,234,58,9);
  flame->palette->setColor(167,246,131,28);
  flame->palette->setColor(168,242,179,28);
  flame->palette->setColor(169,250,187,37);
  flame->palette->setColor(170,250,233,84);
  flame->palette->setColor(171,246,254,102);
  flame->palette->setColor(172,250,254,140);
  flame->palette->setColor(173,254,249,140);
  flame->palette->setColor(174,250,241,102);
  flame->palette->setColor(175,242,195,46);
  flame->palette->setColor(176,246,159,46);
  flame->palette->setColor(177,186,91,37);
  flame->palette->setColor(178,137,43,18);
  flame->palette->setColor(179,101,55,18);
  flame->palette->setColor(180,76,39,18);
  flame->palette->setColor(181,56,11,9);
  flame->palette->setColor(182,44,11,9);
  flame->palette->setColor(183,28,4,0);
  flame->palette->setColor(184,16,0,0);
  flame->palette->setColor(185,4,0,0);
  flame->palette->setColor(186,4,0,0);
  flame->palette->setColor(187,0,0,0);
  flame->palette->setColor(188,0,0,0);
  flame->palette->setColor(189,0,0,0);
  flame->palette->setColor(190,0,0,0);
  flame->palette->setColor(191,4,0,0);
  flame->palette->setColor(192,8,4,0);
  flame->palette->setColor(193,16,8,0);
  flame->palette->setColor(194,24,4,0);
  flame->palette->setColor(195,36,7,0);
  flame->palette->setColor(196,40,4,0);
  flame->palette->setColor(197,32,0,0);
  flame->palette->setColor(198,28,0,0);
  flame->palette->setColor(199,20,0,0);
  flame->palette->setColor(200,12,0,0);
  flame->palette->setColor(201,8,0,0);
  flame->palette->setColor(202,4,0,0);
  flame->palette->setColor(203,0,0,0);
  flame->palette->setColor(204,0,0,0);
  flame->palette->setColor(205,0,0,0);
  flame->palette->setColor(206,0,0,0);
  flame->palette->setColor(207,4,0,0);
  flame->palette->setColor(208,8,0,0);
  flame->palette->setColor(209,24,0,0);
  flame->palette->setColor(210,44,3,0);
  flame->palette->setColor(211,60,0,0);
  flame->palette->setColor(212,77,0,0);
  flame->palette->setColor(213,101,0,0);
  flame->palette->setColor(214,133,3,0);
  flame->palette->setColor(215,162,30,0);
  flame->palette->setColor(216,182,47,0);
  flame->palette->setColor(217,194,79,18);
  flame->palette->setColor(218,197,107,18);
  flame->palette->setColor(219,206,95,18);
  flame->palette->setColor(220,198,86,18);
  flame->palette->setColor(221,198,47,0);
  flame->palette->setColor(222,190,39,9);
  flame->palette->setColor(223,194,18,9);
  flame->palette->setColor(224,182,7,0);
  flame->palette->setColor(225,182,10,0);
  flame->palette->setColor(226,186,22,9);
  flame->palette->setColor(227,190,22,9);
  flame->palette->setColor(228,206,66,9);
  flame->palette->setColor(229,230,98,9);
  flame->palette->setColor(230,246,134,9);
  flame->palette->setColor(231,246,155,28);
  flame->palette->setColor(232,238,138,9);
  flame->palette->setColor(233,238,142,37);
  flame->palette->setColor(234,226,126,18);
  flame->palette->setColor(235,190,87,9);
  flame->palette->setColor(236,141,48,0);
  flame->palette->setColor(237,125,43,9);
  flame->palette->setColor(238,101,15,9);
  flame->palette->setColor(239,101,0,9);
  flame->palette->setColor(240,97,3,0);
  flame->palette->setColor(241,92,7,0);
  flame->palette->setColor(242,89,15,9);
  flame->palette->setColor(243,77,24,9);
  flame->palette->setColor(244,85,7,0);
  flame->palette->setColor(245,64,7,0);
  flame->palette->setColor(246,60,3,0);
  flame->palette->setColor(247,52,7,0);
  flame->palette->setColor(248,48,4,0);
  flame->palette->setColor(249,44,4,0);
  flame->palette->setColor(250,44,3,0);
  flame->palette->setColor(251,48,0,0);
  flame->palette->setColor(252,44,0,0);
  flame->palette->setColor(253,40,7,0);
  flame->palette->setColor(254,36,4,0);
  flame->palette->setColor(255,28,0,0);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=12.29f;
  flame->xForms[0]->color=0.0f;
  flame->xForms[0]->colorSymmetry=0.94034f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=1.0f;
  flame->xForms[0]->coeff10=-0.99115f;
  flame->xForms[0]->coeff11=-0.00917927f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=8.49f;
  flame->xForms[1]->color=0.25f;
  flame->xForms[1]->colorSymmetry=0.98378f;
  flame->xForms[1]->coeff00=-1.0f;
  flame->xForms[1]->coeff01=-0.0f;
  flame->xForms[1]->coeff10=0.0f;
  flame->xForms[1]->coeff11=-1.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.30751f;
  flame->xForms[2]->color=0.5f;
  flame->xForms[2]->colorSymmetry=0.0f;
  flame->xForms[2]->coeff00=0.0f;
  flame->xForms[2]->coeff01=-1.0f;
  flame->xForms[2]->coeff10=1.0f;
  flame->xForms[2]->coeff11=0.0f;
  flame->xForms[2]->coeff20=2.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new Linear3DFunc(), 1.0f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.34417f;
  flame->xForms[3]->color=0.75f;
  flame->xForms[3]->colorSymmetry=0.0f;
  flame->xForms[3]->coeff00=0.0f;
  flame->xForms[3]->coeff01=-1.0f;
  flame->xForms[3]->coeff10=1.0f;
  flame->xForms[3]->coeff11=0.0f;
  flame->xForms[3]->coeff20=-3.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=1.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new Linear3DFunc(), 1.0f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.52859f;
  flame->xForms[4]->color=1.0f;
  flame->xForms[4]->colorSymmetry=0.0f;
  flame->xForms[4]->coeff00=0.04459f;
  flame->xForms[4]->coeff01=-0.22049f;
  flame->xForms[4]->coeff10=0.22049f;
  flame->xForms[4]->coeff11=0.04459f;
  flame->xForms[4]->coeff20=0.16193f;
  flame->xForms[4]->coeff21=0.15969f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.0f;
  flame->xForms[4]->postCoeff21=0.0f;
  {
    Variation *var=flame->xForms[4]->addVariation(new LissajousFunc(), 1.0f);
    var->setParameter("tmin",-3.14f);
    var->setParameter("tmax",3.14f);
    var->setParameter("a",2.75f);
    var->setParameter("b",2.0f);
    var->setParameter("c",0.0f);
    var->setParameter("d",0.0f);
    var->setParameter("e",0.0f);
  }
  {
    Variation *var=flame->xForms[4]->addVariation(new RadialBlurFunc(), 0.28f);
    var->setParameter("angle",0.5f);
  }
  // final xForm
  hostMalloc((void**)&flame->finalXForm, sizeof(XForm));
  flame->finalXForm->init();
  flame->finalXForm->weight=0.0f;
  flame->finalXForm->color=0.0f;
  flame->finalXForm->colorSymmetry=0.0f;
  flame->finalXForm->coeff00=1.0f;
  flame->finalXForm->coeff01=0.0f;
  flame->finalXForm->coeff10=0.0f;
  flame->finalXForm->coeff11=1.0f;
  flame->finalXForm->coeff20=0.0f;
  flame->finalXForm->coeff21=0.0f;
  flame->finalXForm->postCoeff00=1.7f;
  flame->finalXForm->postCoeff01=0.0f;
  flame->finalXForm->postCoeff10=0.0f;
  flame->finalXForm->postCoeff11=2.02f;
  flame->finalXForm->postCoeff20=-0.56622f;
  flame->finalXForm->postCoeff21=0.14687f;
  {
    Variation *var=flame->finalXForm->addVariation(new EpispiralWFFunc(), 1.02f);
    var->setParameter("shift",0.0f);
  }

  return flame;
}

Flame *createExample6Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=865;
  flame->height=487;
  flame->centreX=-0.45f;
  flame->centreY=-0.25f;
  flame->pixelsPerUnit=94.65f;
  flame->camRoll=-26.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=1.4f;
  flame->camPitch=0.0f;
  flame->camYaw=0.0;
  flame->camPerspective=0.0f;
  flame->camZ=0.0f;
  flame->camDOF=0.0f;

  flame->palette->setColor(0,56,13,12);
  flame->palette->setColor(1,71,13,11);
  flame->palette->setColor(2,71,68,56);
  flame->palette->setColor(3,72,20,18);
  flame->palette->setColor(4,88,21,19);
  flame->palette->setColor(5,88,13,11);
  flame->palette->setColor(6,90,70,54);
  flame->palette->setColor(7,92,83,54);
  flame->palette->setColor(8,102,87,50);
  flame->palette->setColor(9,102,59,59);
  flame->palette->setColor(10,103,68,59);
  flame->palette->setColor(11,105,37,31);
  flame->palette->setColor(12,106,16,11);
  flame->palette->setColor(13,110,87,87);
  flame->palette->setColor(14,112,25,18);
  flame->palette->setColor(15,119,105,74);
  flame->palette->setColor(16,121,37,28);
  flame->palette->setColor(17,122,54,44);
  flame->palette->setColor(18,132,106,52);
  flame->palette->setColor(19,133,90,86);
  flame->palette->setColor(20,136,121,94);
  flame->palette->setColor(21,137,38,23);
  flame->palette->setColor(22,137,52,31);
  flame->palette->setColor(23,139,21,11);
  flame->palette->setColor(24,139,28,17);
  flame->palette->setColor(25,140,103,98);
  flame->palette->setColor(26,142,132,102);
  flame->palette->setColor(27,143,137,136);
  flame->palette->setColor(28,143,55,46);
  flame->palette->setColor(29,149,71,57);
  flame->palette->setColor(30,151,122,119);
  flame->palette->setColor(31,152,39,21);
  flame->palette->setColor(32,152,53,30);
  flame->palette->setColor(33,153,68,26);
  flame->palette->setColor(34,154,89,76);
  flame->palette->setColor(35,156,144,101);
  flame->palette->setColor(36,157,133,81);
  flame->palette->setColor(37,161,136,132);
  flame->palette->setColor(38,162,151,146);
  flame->palette->setColor(39,166,124,119);
  flame->palette->setColor(40,167,106,89);
  flame->palette->setColor(41,167,26,11);
  flame->palette->setColor(42,168,41,20);
  flame->palette->setColor(43,168,68,45);
  flame->palette->setColor(44,170,86,75);
  flame->palette->setColor(45,170,57,46);
  flame->palette->setColor(46,172,170,169);
  flame->palette->setColor(47,172,153,149);
  flame->palette->setColor(48,173,141,131);
  flame->palette->setColor(49,173,53,28);
  flame->palette->setColor(50,173,164,154);
  flame->palette->setColor(51,175,12,12);
  flame->palette->setColor(52,178,85,31);
  flame->palette->setColor(53,180,73,70);
  flame->palette->setColor(54,182,121,97);
  flame->palette->setColor(55,183,101,84);
  flame->palette->setColor(56,183,88,76);
  flame->palette->setColor(57,185,69,43);
  flame->palette->setColor(58,189,174,140);
  flame->palette->setColor(59,190,42,23);
  flame->palette->setColor(60,190,182,144);
  flame->palette->setColor(61,191,8,7);
  flame->palette->setColor(62,191,133,121);
  flame->palette->setColor(63,193,154,146);
  flame->palette->setColor(64,194,57,26);
  flame->palette->setColor(65,195,57,57);
  flame->palette->setColor(66,200,70,40);
  flame->palette->setColor(67,200,118,96);
  flame->palette->setColor(68,201,103,65);
  flame->palette->setColor(69,201,86,54);
  flame->palette->setColor(70,201,71,70);
  flame->palette->setColor(71,201,85,77);
  flame->palette->setColor(72,207,184,128);
  flame->palette->setColor(73,207,43,39);
  flame->palette->setColor(74,209,154,152);
  flame->palette->setColor(75,210,201,163);
  flame->palette->setColor(76,212,185,174);
  flame->palette->setColor(77,213,142,141);
  flame->palette->setColor(78,215,70,38);
  flame->palette->setColor(79,215,119,103);
  flame->palette->setColor(80,216,58,20);
  flame->palette->setColor(81,216,87,55);
  flame->palette->setColor(82,218,167,164);
  flame->palette->setColor(83,218,105,60);
  flame->palette->setColor(84,223,206,148);
  flame->palette->setColor(85,223,216,210);
  flame->palette->setColor(86,226,214,150);
  flame->palette->setColor(87,228,138,113);
  flame->palette->setColor(88,231,74,33);
  flame->palette->setColor(89,232,88,52);
  flame->palette->setColor(90,236,134,68);
  flame->palette->setColor(91,238,167,165);
  flame->palette->setColor(92,239,136,133);
  flame->palette->setColor(93,240,121,70);
  flame->palette->setColor(94,241,152,151);
  flame->palette->setColor(95,241,221,147);
  flame->palette->setColor(96,243,101,65);
  flame->palette->setColor(97,244,234,202);
  flame->palette->setColor(98,244,214,209);
  flame->palette->setColor(99,245,221,119);
  flame->palette->setColor(100,246,231,163);
  flame->palette->setColor(101,247,229,139);
  flame->palette->setColor(102,247,88,47);
  flame->palette->setColor(103,248,203,203);
  flame->palette->setColor(104,249,169,140);
  flame->palette->setColor(105,250,182,178);
  flame->palette->setColor(106,252,173,92);
  flame->palette->setColor(107,252,156,84);
  flame->palette->setColor(108,147,148,147);
  flame->palette->setColor(109,162,163,155);
  flame->palette->setColor(110,194,212,202);
  flame->palette->setColor(111,224,226,220);
  flame->palette->setColor(112,211,227,219);
  flame->palette->setColor(113,250,240,176);
  flame->palette->setColor(114,251,245,208);
  flame->palette->setColor(115,251,253,251);
  flame->palette->setColor(116,10,9,20);
  flame->palette->setColor(117,10,18,28);
  flame->palette->setColor(118,25,24,32);
  flame->palette->setColor(119,34,37,47);
  flame->palette->setColor(120,20,36,55);
  flame->palette->setColor(121,35,53,58);
  flame->palette->setColor(122,9,18,60);
  flame->palette->setColor(123,25,21,64);
  flame->palette->setColor(124,12,9,68);
  flame->palette->setColor(125,22,10,69);
  flame->palette->setColor(126,20,38,70);
  flame->palette->setColor(127,32,40,70);
  flame->palette->setColor(128,9,72,61);
  flame->palette->setColor(129,48,43,74);
  flame->palette->setColor(130,33,53,77);
  flame->palette->setColor(131,54,58,78);
  flame->palette->setColor(132,6,82,70);
  flame->palette->setColor(133,72,71,84);
  flame->palette->setColor(134,56,67,86);
  flame->palette->setColor(135,44,67,90);
  flame->palette->setColor(136,60,86,95);
  flame->palette->setColor(137,28,101,84);
  flame->palette->setColor(138,36,102,84);
  flame->palette->setColor(139,51,61,102);
  flame->palette->setColor(140,73,76,103);
  flame->palette->setColor(141,53,70,104);
  flame->palette->setColor(142,75,86,105);
  flame->palette->setColor(143,88,88,105);
  flame->palette->setColor(144,57,87,112);
  flame->palette->setColor(145,87,111,113);
  flame->palette->setColor(146,104,104,116);
  flame->palette->setColor(147,90,99,117);
  flame->palette->setColor(148,74,99,118);
  flame->palette->setColor(149,107,116,121);
  flame->palette->setColor(150,20,122,113);
  flame->palette->setColor(151,57,106,127);
  flame->palette->setColor(152,44,130,116);
  flame->palette->setColor(153,20,132,121);
  flame->palette->setColor(154,44,126,132);
  flame->palette->setColor(155,110,107,134);
  flame->palette->setColor(156,108,116,134);
  flame->palette->setColor(157,120,120,135);
  flame->palette->setColor(158,85,99,137);
  flame->palette->setColor(159,76,92,138);
  flame->palette->setColor(160,130,133,138);
  flame->palette->setColor(161,85,112,139);
  flame->palette->setColor(162,85,93,139);
  flame->palette->setColor(163,112,132,145);
  flame->palette->setColor(164,60,150,148);
  flame->palette->setColor(165,95,135,153);
  flame->palette->setColor(166,126,144,153);
  flame->palette->setColor(167,90,151,160);
  flame->palette->setColor(168,60,164,159);
  flame->palette->setColor(169,148,153,169);
  flame->palette->setColor(170,132,150,172);
  flame->palette->setColor(171,142,136,175);
  flame->palette->setColor(172,115,132,177);
  flame->palette->setColor(173,135,125,179);
  flame->palette->setColor(174,108,178,180);
  flame->palette->setColor(175,128,136,180);
  flame->palette->setColor(176,146,165,182);
  flame->palette->setColor(177,163,169,185);
  flame->palette->setColor(178,188,189,189);
  flame->palette->setColor(179,123,126,189);
  flame->palette->setColor(180,161,184,191);
  flame->palette->setColor(181,178,184,192);
  flame->palette->setColor(182,132,158,193);
  flame->palette->setColor(183,160,194,196);
  flame->palette->setColor(184,100,187,196);
  flame->palette->setColor(185,179,196,192);
  flame->palette->setColor(186,123,193,201);
  flame->palette->setColor(187,195,200,201);
  flame->palette->setColor(188,97,201,199);
  flame->palette->setColor(189,112,206,204);
  flame->palette->setColor(190,211,212,212);
  flame->palette->setColor(191,162,184,212);
  flame->palette->setColor(192,148,215,224);
  flame->palette->setColor(193,189,185,225);
  flame->palette->setColor(194,222,221,226);
  flame->palette->setColor(195,178,184,226);
  flame->palette->setColor(196,193,202,227);
  flame->palette->setColor(197,192,213,227);
  flame->palette->setColor(198,143,226,228);
  flame->palette->setColor(199,124,226,228);
  flame->palette->setColor(200,226,228,230);
  flame->palette->setColor(201,189,178,231);
  flame->palette->setColor(202,178,177,232);
  flame->palette->setColor(203,211,216,232);
  flame->palette->setColor(204,208,204,243);
  flame->palette->setColor(205,196,229,244);
  flame->palette->setColor(206,226,250,250);
  flame->palette->setColor(207,186,248,251);
  flame->palette->setColor(208,23,11,26);
  flame->palette->setColor(209,39,12,15);
  flame->palette->setColor(210,39,27,34);
  flame->palette->setColor(211,47,35,36);
  flame->palette->setColor(212,51,41,50);
  flame->palette->setColor(213,55,21,23);
  flame->palette->setColor(214,57,51,57);
  flame->palette->setColor(215,38,11,61);
  flame->palette->setColor(216,40,24,61);
  flame->palette->setColor(217,69,43,50);
  flame->palette->setColor(218,55,10,70);
  flame->palette->setColor(219,71,54,59);
  flame->palette->setColor(220,56,21,74);
  flame->palette->setColor(221,69,61,80);
  flame->palette->setColor(222,68,20,83);
  flame->palette->setColor(223,73,38,86);
  flame->palette->setColor(224,86,59,61);
  flame->palette->setColor(225,86,43,46);
  flame->palette->setColor(226,73,28,86);
  flame->palette->setColor(227,88,73,80);
  flame->palette->setColor(228,86,84,89);
  flame->palette->setColor(229,86,40,94);
  flame->palette->setColor(230,89,56,95);
  flame->palette->setColor(231,88,76,100);
  flame->palette->setColor(232,102,60,83);
  flame->palette->setColor(233,104,74,75);
  flame->palette->setColor(234,102,90,105);
  flame->palette->setColor(235,103,75,107);
  flame->palette->setColor(236,118,91,112);
  flame->palette->setColor(237,119,105,113);
  flame->palette->setColor(238,121,117,119);
  flame->palette->setColor(239,119,72,132);
  flame->palette->setColor(240,136,119,123);
  flame->palette->setColor(241,139,109,110);
  flame->palette->setColor(242,140,99,137);
  flame->palette->setColor(243,166,155,172);
  flame->palette->setColor(244,191,172,175);
  flame->palette->setColor(245,204,202,203);
  flame->palette->setColor(246,211,101,102);
  flame->palette->setColor(247,212,62,68);
  flame->palette->setColor(248,216,187,192);
  flame->palette->setColor(249,222,157,158);
  flame->palette->setColor(250,225,205,210);
  flame->palette->setColor(251,238,232,234);
  flame->palette->setColor(252,240,219,224);
  flame->palette->setColor(253,242,205,236);
  flame->palette->setColor(254,222,204,250);
  flame->palette->setColor(255,252,124,128);

  flame->xFormCount=3;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=28.56f;
  flame->xForms[0]->color=0.0f;
  flame->xForms[0]->colorSymmetry=1.0f;
  flame->xForms[0]->coeff00=0.06647f;
  flame->xForms[0]->coeff01=0.02806f;
  flame->xForms[0]->coeff10=-0.02806f;
  flame->xForms[0]->coeff11=0.06647f;
  flame->xForms[0]->coeff20=-0.07481f;
  flame->xForms[0]->coeff21=-0.03092f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new SphericalFunc(), 2.18f);
  flame->xForms[0]->addVariation(new EyefishFunc(), 0.18735f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=1.12f;
  flame->xForms[1]->color=0.33333f;
  flame->xForms[1]->colorSymmetry=-0.5f;
  flame->xForms[1]->coeff00=2.71f;
  flame->xForms[1]->coeff01=0.57081f;
  flame->xForms[1]->coeff10=-0.57081f;
  flame->xForms[1]->coeff11=2.71f;
  flame->xForms[1]->coeff20=0.70765f;
  flame->xForms[1]->coeff21=-0.80344f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new BubbleFunc(), 0.36117f);
  flame->xForms[1]->addVariation(new PreBlurFunc(), 7.33f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=1.85f;
  flame->xForms[2]->color=0.66667f;
  flame->xForms[2]->colorSymmetry=-0.5f;
  flame->xForms[2]->coeff00=0.89688f;
  flame->xForms[2]->coeff01=-0.44227f;
  flame->xForms[2]->coeff10=0.44227f;
  flame->xForms[2]->coeff11=0.89688f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  {
    Variation *var=flame->xForms[2]->addVariation(new FluxFunc(), 0.65f);
    var->setParameter("spread",0.3f);
  }
  // final xForm
  hostMalloc((void**)&flame->finalXForm, sizeof(XForm));
  flame->finalXForm->init();
  flame->finalXForm->weight=0.0f;
  flame->finalXForm->color=0.0f;
  flame->finalXForm->colorSymmetry=0.0f;
  flame->finalXForm->coeff00=1.0f;
  flame->finalXForm->coeff01=0.0f;
  flame->finalXForm->coeff10=0.0f;
  flame->finalXForm->coeff11=1.0f;
  flame->finalXForm->coeff20=0.0f;
  flame->finalXForm->coeff21=0.0f;
  flame->finalXForm->postCoeff00=1.0f;
  flame->finalXForm->postCoeff01=0.0f;
  flame->finalXForm->postCoeff10=0.0f;
  flame->finalXForm->postCoeff11=1.0f;
  flame->finalXForm->postCoeff20=0.0f;
  flame->finalXForm->postCoeff21=0.0f;
  {
    Variation *var=flame->finalXForm->addVariation(new JuliaNFunc(), 1.0f);
    var->setParameter("power",3.0f);
    var->setParameter("dist",1.0f);
  }

  return flame;
}

Flame *createExample7Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=882;
  flame->height=496;
  flame->centreX=-0.4f;
  flame->centreY=-0.15f;
  flame->pixelsPerUnit=118.0f;
  flame->camRoll=0.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=3.6f;
  flame->camPitch=48.0f;
  flame->camYaw=112.0;
  flame->camPerspective=0.32f;
  flame->camZ=0.0f;
  flame->camDOF=0.29f;

  flame->palette->setColor(0,61,228,219);
  flame->palette->setColor(1,65,224,217);
  flame->palette->setColor(2,68,219,215);
  flame->palette->setColor(3,72,215,213);
  flame->palette->setColor(4,75,211,211);
  flame->palette->setColor(5,79,206,209);
  flame->palette->setColor(6,83,202,207);
  flame->palette->setColor(7,86,198,205);
  flame->palette->setColor(8,90,193,203);
  flame->palette->setColor(9,93,189,201);
  flame->palette->setColor(10,97,185,199);
  flame->palette->setColor(11,101,180,197);
  flame->palette->setColor(12,104,176,195);
  flame->palette->setColor(13,108,172,193);
  flame->palette->setColor(14,112,167,191);
  flame->palette->setColor(15,115,163,189);
  flame->palette->setColor(16,119,159,187);
  flame->palette->setColor(17,122,154,185);
  flame->palette->setColor(18,126,150,183);
  flame->palette->setColor(19,130,146,181);
  flame->palette->setColor(20,133,141,179);
  flame->palette->setColor(21,137,137,177);
  flame->palette->setColor(22,140,133,175);
  flame->palette->setColor(23,144,128,173);
  flame->palette->setColor(24,148,124,171);
  flame->palette->setColor(25,151,120,169);
  flame->palette->setColor(26,155,115,167);
  flame->palette->setColor(27,158,111,165);
  flame->palette->setColor(28,162,107,163);
  flame->palette->setColor(29,166,102,161);
  flame->palette->setColor(30,169,98,159);
  flame->palette->setColor(31,173,94,157);
  flame->palette->setColor(32,177,89,155);
  flame->palette->setColor(33,180,85,153);
  flame->palette->setColor(34,184,81,151);
  flame->palette->setColor(35,187,76,149);
  flame->palette->setColor(36,191,72,147);
  flame->palette->setColor(37,195,68,145);
  flame->palette->setColor(38,198,63,143);
  flame->palette->setColor(39,202,59,141);
  flame->palette->setColor(40,205,55,139);
  flame->palette->setColor(41,209,50,137);
  flame->palette->setColor(42,213,46,135);
  flame->palette->setColor(43,214,44,133);
  flame->palette->setColor(44,209,48,130);
  flame->palette->setColor(45,205,51,128);
  flame->palette->setColor(46,201,55,125);
  flame->palette->setColor(47,197,59,123);
  flame->palette->setColor(48,193,62,120);
  flame->palette->setColor(49,189,66,117);
  flame->palette->setColor(50,184,69,115);
  flame->palette->setColor(51,180,73,112);
  flame->palette->setColor(52,176,77,109);
  flame->palette->setColor(53,172,80,107);
  flame->palette->setColor(54,168,84,104);
  flame->palette->setColor(55,164,88,101);
  flame->palette->setColor(56,159,91,99);
  flame->palette->setColor(57,155,95,96);
  flame->palette->setColor(58,151,98,93);
  flame->palette->setColor(59,147,102,91);
  flame->palette->setColor(60,143,106,88);
  flame->palette->setColor(61,139,109,85);
  flame->palette->setColor(62,134,113,83);
  flame->palette->setColor(63,130,116,80);
  flame->palette->setColor(64,126,120,78);
  flame->palette->setColor(65,122,124,75);
  flame->palette->setColor(66,118,127,72);
  flame->palette->setColor(67,113,131,70);
  flame->palette->setColor(68,109,134,67);
  flame->palette->setColor(69,105,138,64);
  flame->palette->setColor(70,101,142,62);
  flame->palette->setColor(71,97,145,59);
  flame->palette->setColor(72,93,149,56);
  flame->palette->setColor(73,88,152,54);
  flame->palette->setColor(74,84,156,51);
  flame->palette->setColor(75,80,160,48);
  flame->palette->setColor(76,76,163,46);
  flame->palette->setColor(77,72,167,43);
  flame->palette->setColor(78,68,171,40);
  flame->palette->setColor(79,63,174,38);
  flame->palette->setColor(80,59,178,35);
  flame->palette->setColor(81,55,181,32);
  flame->palette->setColor(82,51,185,30);
  flame->palette->setColor(83,47,189,27);
  flame->palette->setColor(84,43,192,25);
  flame->palette->setColor(85,38,196,22);
  flame->palette->setColor(86,39,198,21);
  flame->palette->setColor(87,43,199,21);
  flame->palette->setColor(88,46,200,21);
  flame->palette->setColor(89,50,201,21);
  flame->palette->setColor(90,53,202,21);
  flame->palette->setColor(91,57,203,21);
  flame->palette->setColor(92,60,204,21);
  flame->palette->setColor(93,64,205,22);
  flame->palette->setColor(94,67,206,22);
  flame->palette->setColor(95,71,207,22);
  flame->palette->setColor(96,75,208,22);
  flame->palette->setColor(97,78,209,22);
  flame->palette->setColor(98,82,210,22);
  flame->palette->setColor(99,85,211,22);
  flame->palette->setColor(100,89,212,22);
  flame->palette->setColor(101,92,213,22);
  flame->palette->setColor(102,96,214,22);
  flame->palette->setColor(103,99,215,22);
  flame->palette->setColor(104,103,216,22);
  flame->palette->setColor(105,106,217,22);
  flame->palette->setColor(106,110,218,22);
  flame->palette->setColor(107,113,219,23);
  flame->palette->setColor(108,117,220,23);
  flame->palette->setColor(109,120,221,23);
  flame->palette->setColor(110,124,222,23);
  flame->palette->setColor(111,127,223,23);
  flame->palette->setColor(112,131,224,23);
  flame->palette->setColor(113,134,225,23);
  flame->palette->setColor(114,138,226,23);
  flame->palette->setColor(115,141,227,23);
  flame->palette->setColor(116,145,228,23);
  flame->palette->setColor(117,148,229,23);
  flame->palette->setColor(118,152,230,23);
  flame->palette->setColor(119,155,231,23);
  flame->palette->setColor(120,159,232,23);
  flame->palette->setColor(121,162,233,24);
  flame->palette->setColor(122,166,234,24);
  flame->palette->setColor(123,169,235,24);
  flame->palette->setColor(124,173,236,24);
  flame->palette->setColor(125,176,237,24);
  flame->palette->setColor(126,180,238,24);
  flame->palette->setColor(127,183,239,24);
  flame->palette->setColor(128,187,240,24);
  flame->palette->setColor(129,187,235,24);
  flame->palette->setColor(130,186,231,23);
  flame->palette->setColor(131,186,226,23);
  flame->palette->setColor(132,185,222,23);
  flame->palette->setColor(133,185,217,22);
  flame->palette->setColor(134,184,213,22);
  flame->palette->setColor(135,184,208,21);
  flame->palette->setColor(136,184,204,21);
  flame->palette->setColor(137,183,199,21);
  flame->palette->setColor(138,183,195,20);
  flame->palette->setColor(139,182,190,20);
  flame->palette->setColor(140,182,186,20);
  flame->palette->setColor(141,182,181,19);
  flame->palette->setColor(142,181,177,19);
  flame->palette->setColor(143,181,172,18);
  flame->palette->setColor(144,180,168,18);
  flame->palette->setColor(145,180,163,18);
  flame->palette->setColor(146,179,159,17);
  flame->palette->setColor(147,179,154,17);
  flame->palette->setColor(148,179,150,17);
  flame->palette->setColor(149,178,145,16);
  flame->palette->setColor(150,178,140,16);
  flame->palette->setColor(151,177,136,15);
  flame->palette->setColor(152,177,131,15);
  flame->palette->setColor(153,176,127,15);
  flame->palette->setColor(154,176,122,14);
  flame->palette->setColor(155,176,118,14);
  flame->palette->setColor(156,175,113,14);
  flame->palette->setColor(157,175,109,13);
  flame->palette->setColor(158,174,104,13);
  flame->palette->setColor(159,174,100,12);
  flame->palette->setColor(160,174,95,12);
  flame->palette->setColor(161,173,91,12);
  flame->palette->setColor(162,173,86,11);
  flame->palette->setColor(163,172,82,11);
  flame->palette->setColor(164,172,77,11);
  flame->palette->setColor(165,171,73,10);
  flame->palette->setColor(166,171,68,10);
  flame->palette->setColor(167,171,64,9);
  flame->palette->setColor(168,170,59,9);
  flame->palette->setColor(169,170,55,9);
  flame->palette->setColor(170,169,50,8);
  flame->palette->setColor(171,168,48,10);
  flame->palette->setColor(172,166,50,14);
  flame->palette->setColor(173,164,52,19);
  flame->palette->setColor(174,162,55,24);
  flame->palette->setColor(175,160,57,29);
  flame->palette->setColor(176,159,59,34);
  flame->palette->setColor(177,157,62,39);
  flame->palette->setColor(178,155,64,43);
  flame->palette->setColor(179,153,66,48);
  flame->palette->setColor(180,151,69,53);
  flame->palette->setColor(181,149,71,58);
  flame->palette->setColor(182,147,73,63);
  flame->palette->setColor(183,145,76,68);
  flame->palette->setColor(184,143,78,72);
  flame->palette->setColor(185,141,80,77);
  flame->palette->setColor(186,139,83,82);
  flame->palette->setColor(187,137,85,87);
  flame->palette->setColor(188,135,87,92);
  flame->palette->setColor(189,133,90,97);
  flame->palette->setColor(190,131,92,101);
  flame->palette->setColor(191,129,94,106);
  flame->palette->setColor(192,127,97,111);
  flame->palette->setColor(193,125,99,116);
  flame->palette->setColor(194,123,101,121);
  flame->palette->setColor(195,121,103,125);
  flame->palette->setColor(196,119,106,130);
  flame->palette->setColor(197,117,108,135);
  flame->palette->setColor(198,115,110,140);
  flame->palette->setColor(199,113,113,145);
  flame->palette->setColor(200,111,115,150);
  flame->palette->setColor(201,109,117,154);
  flame->palette->setColor(202,107,120,159);
  flame->palette->setColor(203,105,122,164);
  flame->palette->setColor(204,103,124,169);
  flame->palette->setColor(205,101,127,174);
  flame->palette->setColor(206,99,129,179);
  flame->palette->setColor(207,97,131,183);
  flame->palette->setColor(208,96,134,188);
  flame->palette->setColor(209,94,136,193);
  flame->palette->setColor(210,92,138,198);
  flame->palette->setColor(211,90,141,203);
  flame->palette->setColor(212,88,143,208);
  flame->palette->setColor(213,86,145,212);
  flame->palette->setColor(214,87,145,211);
  flame->palette->setColor(215,91,144,207);
  flame->palette->setColor(216,95,143,202);
  flame->palette->setColor(217,98,142,198);
  flame->palette->setColor(218,102,141,193);
  flame->palette->setColor(219,105,140,189);
  flame->palette->setColor(220,109,139,184);
  flame->palette->setColor(221,112,138,180);
  flame->palette->setColor(222,116,136,175);
  flame->palette->setColor(223,120,135,171);
  flame->palette->setColor(224,123,134,167);
  flame->palette->setColor(225,127,133,162);
  flame->palette->setColor(226,130,132,158);
  flame->palette->setColor(227,134,131,153);
  flame->palette->setColor(228,138,130,149);
  flame->palette->setColor(229,141,129,144);
  flame->palette->setColor(230,145,128,140);
  flame->palette->setColor(231,148,127,135);
  flame->palette->setColor(232,152,125,131);
  flame->palette->setColor(233,156,124,126);
  flame->palette->setColor(234,159,123,122);
  flame->palette->setColor(235,163,122,118);
  flame->palette->setColor(236,166,121,113);
  flame->palette->setColor(237,170,120,109);
  flame->palette->setColor(238,173,119,104);
  flame->palette->setColor(239,177,118,100);
  flame->palette->setColor(240,181,117,95);
  flame->palette->setColor(241,184,116,91);
  flame->palette->setColor(242,188,114,86);
  flame->palette->setColor(243,191,113,82);
  flame->palette->setColor(244,195,112,77);
  flame->palette->setColor(245,199,111,73);
  flame->palette->setColor(246,202,110,69);
  flame->palette->setColor(247,206,109,64);
  flame->palette->setColor(248,209,108,60);
  flame->palette->setColor(249,213,107,55);
  flame->palette->setColor(250,216,106,51);
  flame->palette->setColor(251,220,105,46);
  flame->palette->setColor(252,224,103,42);
  flame->palette->setColor(253,227,102,37);
  flame->palette->setColor(254,231,101,33);
  flame->palette->setColor(255,234,100,28);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=3.35f;
  flame->xForms[0]->color=0.50178f;
  flame->xForms[0]->colorSymmetry=0.95949f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=-1.0f;
  flame->xForms[0]->coeff10=1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new Spherical3DFunc(), 1.0f);
  flame->xForms[0]->modifiedWeights[3]=0.0f;
  flame->xForms[0]->modifiedWeights[4]=0.0f;

  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=1.48f;
  flame->xForms[1]->color=0.69581f;
  flame->xForms[1]->colorSymmetry=0.94266f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=-1.0f;
  flame->xForms[1]->coeff10=1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Spherical3DFunc(), 1.0f);
  flame->xForms[1]->modifiedWeights[3]=0.0f;
  flame->xForms[1]->modifiedWeights[4]=0.0f;
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.5f;
  flame->xForms[2]->color=0.81376f;
  flame->xForms[2]->colorSymmetry=-1.0f;
  flame->xForms[2]->coeff00=1.0f;
  flame->xForms[2]->coeff01=0.0f;
  flame->xForms[2]->coeff10=0.0f;
  flame->xForms[2]->coeff11=1.0f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=5.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new PreBlurFunc(), 0.35174f);
  flame->xForms[2]->addVariation(new ZTranslateFunc(), 0.07285f);
  flame->xForms[2]->addVariation(new CylinderFunc(), 0.1603f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.5f;
  flame->xForms[3]->color=0.60452f;
  flame->xForms[3]->colorSymmetry=-1.0f;
  flame->xForms[3]->coeff00=1.0f;
  flame->xForms[3]->coeff01=0.0f;
  flame->xForms[3]->coeff10=0.0f;
  flame->xForms[3]->coeff11=1.0f;
  flame->xForms[3]->coeff20=0.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=3.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new PreBlurFunc(), 0.04222f);
  flame->xForms[3]->addVariation(new ZTranslateFunc(), 0.36091f);
  flame->xForms[3]->addVariation(new CylinderFunc(), 0.07043f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.1f;
  flame->xForms[4]->color=0.85132f;
  flame->xForms[4]->colorSymmetry=-1.0f;
  flame->xForms[4]->coeff00=1.0f;
  flame->xForms[4]->coeff01=0.0f;
  flame->xForms[4]->coeff10=0.0f;
  flame->xForms[4]->coeff11=1.0f;
  flame->xForms[4]->coeff20=0.0f;
  flame->xForms[4]->coeff21=0.0f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.3f;
  flame->xForms[4]->postCoeff21=0.0f;
  flame->xForms[4]->addVariation(new GaussianBlurFunc(), 0.00565613f);
  flame->xForms[4]->addVariation(new ZTranslateFunc(), 0.00621804f);
  // final xForm
  hostMalloc((void**)&flame->finalXForm, sizeof(XForm));
  flame->finalXForm->init();
  flame->finalXForm->weight=0.1f;
  flame->finalXForm->color=1.0f;
  flame->finalXForm->colorSymmetry=0.76179f;
  flame->finalXForm->coeff00=0.70711f;
  flame->finalXForm->coeff01=-0.70711f;
  flame->finalXForm->coeff10=0.70711f;
  flame->finalXForm->coeff11=0.70711f;
  flame->finalXForm->coeff20=0.0f;
  flame->finalXForm->coeff21=0.25f;
  flame->finalXForm->postCoeff00=1.0f;
  flame->finalXForm->postCoeff01=0.0f;
  flame->finalXForm->postCoeff10=0.0f;
  flame->finalXForm->postCoeff11=1.0f;
  flame->finalXForm->postCoeff20=0.0f;
  flame->finalXForm->postCoeff21=-0.25f;
  flame->finalXForm->addVariation(new Spherical3DFunc(), 0.51515f);

  return flame;
}

// 2D flowers (inside spherical 3d "grid")
Flame *createExample8Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=485;
  flame->height=273;
  flame->centreX=0.0f;
  flame->centreY=0.0f;
  flame->pixelsPerUnit=53.07f;
  flame->camRoll=90.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=4.0f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=2.4f;
  flame->camPitch=0.0f;
  flame->camYaw=0.0;
  flame->camPerspective=0.32f;
  flame->camZ=0.0f;
  flame->camDOF=0.0f;

  flame->palette->setColor(0,105,168,154);
  flame->palette->setColor(1,112,161,148);
  flame->palette->setColor(2,118,155,143);
  flame->palette->setColor(3,125,148,138);
  flame->palette->setColor(4,131,142,133);
  flame->palette->setColor(5,138,136,127);
  flame->palette->setColor(6,144,129,122);
  flame->palette->setColor(7,151,123,117);
  flame->palette->setColor(8,157,116,111);
  flame->palette->setColor(9,163,110,106);
  flame->palette->setColor(10,170,104,101);
  flame->palette->setColor(11,176,97,96);
  flame->palette->setColor(12,183,91,90);
  flame->palette->setColor(13,189,84,85);
  flame->palette->setColor(14,196,78,80);
  flame->palette->setColor(15,202,72,75);
  flame->palette->setColor(16,209,65,69);
  flame->palette->setColor(17,215,59,64);
  flame->palette->setColor(18,222,52,59);
  flame->palette->setColor(19,224,51,57);
  flame->palette->setColor(20,218,59,64);
  flame->palette->setColor(21,212,67,71);
  flame->palette->setColor(22,206,76,77);
  flame->palette->setColor(23,200,84,84);
  flame->palette->setColor(24,193,92,91);
  flame->palette->setColor(25,187,101,98);
  flame->palette->setColor(26,181,109,104);
  flame->palette->setColor(27,175,117,111);
  flame->palette->setColor(28,169,126,118);
  flame->palette->setColor(29,163,134,125);
  flame->palette->setColor(30,157,142,131);
  flame->palette->setColor(31,150,151,138);
  flame->palette->setColor(32,144,159,145);
  flame->palette->setColor(33,138,167,152);
  flame->palette->setColor(34,132,175,158);
  flame->palette->setColor(35,126,184,165);
  flame->palette->setColor(36,120,192,172);
  flame->palette->setColor(37,114,200,179);
  flame->palette->setColor(38,107,209,185);
  flame->palette->setColor(39,110,209,188);
  flame->palette->setColor(40,117,203,189);
  flame->palette->setColor(41,124,197,190);
  flame->palette->setColor(42,131,192,190);
  flame->palette->setColor(43,139,186,191);
  flame->palette->setColor(44,146,181,191);
  flame->palette->setColor(45,153,175,192);
  flame->palette->setColor(46,161,169,193);
  flame->palette->setColor(47,168,164,193);
  flame->palette->setColor(48,175,158,194);
  flame->palette->setColor(49,183,153,194);
  flame->palette->setColor(50,190,147,195);
  flame->palette->setColor(51,197,142,196);
  flame->palette->setColor(52,205,136,196);
  flame->palette->setColor(53,212,130,197);
  flame->palette->setColor(54,219,125,198);
  flame->palette->setColor(55,227,119,198);
  flame->palette->setColor(56,234,114,199);
  flame->palette->setColor(57,241,108,199);
  flame->palette->setColor(58,248,102,200);
  flame->palette->setColor(59,239,108,197);
  flame->palette->setColor(60,227,114,193);
  flame->palette->setColor(61,216,120,190);
  flame->palette->setColor(62,205,126,186);
  flame->palette->setColor(63,193,133,183);
  flame->palette->setColor(64,182,139,180);
  flame->palette->setColor(65,171,145,176);
  flame->palette->setColor(66,159,151,173);
  flame->palette->setColor(67,148,157,169);
  flame->palette->setColor(68,137,163,166);
  flame->palette->setColor(69,125,170,162);
  flame->palette->setColor(70,114,176,159);
  flame->palette->setColor(71,103,182,155);
  flame->palette->setColor(72,91,188,152);
  flame->palette->setColor(73,80,194,148);
  flame->palette->setColor(74,69,201,145);
  flame->palette->setColor(75,57,207,142);
  flame->palette->setColor(76,46,213,138);
  flame->palette->setColor(77,35,219,135);
  flame->palette->setColor(78,27,223,132);
  flame->palette->setColor(79,31,216,133);
  flame->palette->setColor(80,35,210,134);
  flame->palette->setColor(81,39,204,135);
  flame->palette->setColor(82,43,198,136);
  flame->palette->setColor(83,46,192,137);
  flame->palette->setColor(84,50,185,138);
  flame->palette->setColor(85,54,179,139);
  flame->palette->setColor(86,58,173,140);
  flame->palette->setColor(87,62,167,141);
  flame->palette->setColor(88,66,161,142);
  flame->palette->setColor(89,70,154,143);
  flame->palette->setColor(90,74,148,144);
  flame->palette->setColor(91,78,142,145);
  flame->palette->setColor(92,82,136,146);
  flame->palette->setColor(93,86,130,147);
  flame->palette->setColor(94,89,123,148);
  flame->palette->setColor(95,93,117,149);
  flame->palette->setColor(96,97,111,150);
  flame->palette->setColor(97,101,105,151);
  flame->palette->setColor(98,107,100,150);
  flame->palette->setColor(99,115,96,148);
  flame->palette->setColor(100,123,92,145);
  flame->palette->setColor(101,130,88,143);
  flame->palette->setColor(102,138,84,141);
  flame->palette->setColor(103,146,81,139);
  flame->palette->setColor(104,153,77,137);
  flame->palette->setColor(105,161,73,135);
  flame->palette->setColor(106,169,69,132);
  flame->palette->setColor(107,177,65,130);
  flame->palette->setColor(108,184,61,128);
  flame->palette->setColor(109,192,57,126);
  flame->palette->setColor(110,200,54,124);
  flame->palette->setColor(111,208,50,121);
  flame->palette->setColor(112,215,46,119);
  flame->palette->setColor(113,223,42,117);
  flame->palette->setColor(114,231,38,115);
  flame->palette->setColor(115,238,34,113);
  flame->palette->setColor(116,246,30,111);
  flame->palette->setColor(117,254,27,108);
  flame->palette->setColor(118,247,33,106);
  flame->palette->setColor(119,238,42,103);
  flame->palette->setColor(120,228,50,100);
  flame->palette->setColor(121,219,58,97);
  flame->palette->setColor(122,209,67,94);
  flame->palette->setColor(123,200,75,91);
  flame->palette->setColor(124,190,84,89);
  flame->palette->setColor(125,181,92,86);
  flame->palette->setColor(126,171,101,83);
  flame->palette->setColor(127,162,109,80);
  flame->palette->setColor(128,153,117,77);
  flame->palette->setColor(129,143,126,74);
  flame->palette->setColor(130,134,134,71);
  flame->palette->setColor(131,124,143,69);
  flame->palette->setColor(132,115,151,66);
  flame->palette->setColor(133,105,160,63);
  flame->palette->setColor(134,96,168,60);
  flame->palette->setColor(135,86,176,57);
  flame->palette->setColor(136,77,185,54);
  flame->palette->setColor(137,70,192,53);
  flame->palette->setColor(138,75,195,61);
  flame->palette->setColor(139,80,198,70);
  flame->palette->setColor(140,86,201,78);
  flame->palette->setColor(141,91,204,86);
  flame->palette->setColor(142,96,207,94);
  flame->palette->setColor(143,102,210,102);
  flame->palette->setColor(144,107,213,110);
  flame->palette->setColor(145,112,216,118);
  flame->palette->setColor(146,117,219,126);
  flame->palette->setColor(147,123,222,135);
  flame->palette->setColor(148,128,225,143);
  flame->palette->setColor(149,133,228,151);
  flame->palette->setColor(150,138,231,159);
  flame->palette->setColor(151,144,234,167);
  flame->palette->setColor(152,149,237,175);
  flame->palette->setColor(153,154,240,183);
  flame->palette->setColor(154,160,243,191);
  flame->palette->setColor(155,165,246,200);
  flame->palette->setColor(156,170,249,208);
  flame->palette->setColor(157,172,247,208);
  flame->palette->setColor(158,170,240,199);
  flame->palette->setColor(159,168,232,190);
  flame->palette->setColor(160,166,225,181);
  flame->palette->setColor(161,164,217,172);
  flame->palette->setColor(162,162,209,163);
  flame->palette->setColor(163,160,202,154);
  flame->palette->setColor(164,158,194,145);
  flame->palette->setColor(165,156,187,136);
  flame->palette->setColor(166,154,179,126);
  flame->palette->setColor(167,152,171,117);
  flame->palette->setColor(168,150,164,108);
  flame->palette->setColor(169,148,156,99);
  flame->palette->setColor(170,146,148,90);
  flame->palette->setColor(171,144,141,81);
  flame->palette->setColor(172,142,133,72);
  flame->palette->setColor(173,140,126,63);
  flame->palette->setColor(174,138,118,54);
  flame->palette->setColor(175,136,110,45);
  flame->palette->setColor(176,133,103,36);
  flame->palette->setColor(177,138,104,36);
  flame->palette->setColor(178,144,109,38);
  flame->palette->setColor(179,150,113,40);
  flame->palette->setColor(180,156,117,42);
  flame->palette->setColor(181,162,122,45);
  flame->palette->setColor(182,168,126,47);
  flame->palette->setColor(183,174,130,49);
  flame->palette->setColor(184,180,135,51);
  flame->palette->setColor(185,186,139,54);
  flame->palette->setColor(186,192,143,56);
  flame->palette->setColor(187,198,147,58);
  flame->palette->setColor(188,204,152,60);
  flame->palette->setColor(189,210,156,63);
  flame->palette->setColor(190,216,160,65);
  flame->palette->setColor(191,222,165,67);
  flame->palette->setColor(192,228,169,69);
  flame->palette->setColor(193,234,173,71);
  flame->palette->setColor(194,240,178,74);
  flame->palette->setColor(195,246,182,76);
  flame->palette->setColor(196,251,186,78);
  flame->palette->setColor(197,242,180,77);
  flame->palette->setColor(198,232,174,76);
  flame->palette->setColor(199,222,169,75);
  flame->palette->setColor(200,212,163,74);
  flame->palette->setColor(201,203,158,73);
  flame->palette->setColor(202,193,152,72);
  flame->palette->setColor(203,183,146,71);
  flame->palette->setColor(204,174,141,70);
  flame->palette->setColor(205,164,135,69);
  flame->palette->setColor(206,154,130,68);
  flame->palette->setColor(207,145,124,67);
  flame->palette->setColor(208,135,119,66);
  flame->palette->setColor(209,125,113,65);
  flame->palette->setColor(210,115,107,64);
  flame->palette->setColor(211,106,102,63);
  flame->palette->setColor(212,96,96,62);
  flame->palette->setColor(213,86,91,61);
  flame->palette->setColor(214,77,85,60);
  flame->palette->setColor(215,67,79,59);
  flame->palette->setColor(216,60,78,57);
  flame->palette->setColor(217,59,84,54);
  flame->palette->setColor(218,57,89,51);
  flame->palette->setColor(219,55,94,49);
  flame->palette->setColor(220,53,100,46);
  flame->palette->setColor(221,51,105,43);
  flame->palette->setColor(222,50,111,40);
  flame->palette->setColor(223,48,116,37);
  flame->palette->setColor(224,46,122,35);
  flame->palette->setColor(225,44,127,32);
  flame->palette->setColor(226,43,132,29);
  flame->palette->setColor(227,41,138,26);
  flame->palette->setColor(228,39,143,23);
  flame->palette->setColor(229,37,149,21);
  flame->palette->setColor(230,35,154,18);
  flame->palette->setColor(231,34,160,15);
  flame->palette->setColor(232,32,165,12);
  flame->palette->setColor(233,30,170,9);
  flame->palette->setColor(234,28,176,7);
  flame->palette->setColor(235,27,181,4);
  flame->palette->setColor(236,32,179,5);
  flame->palette->setColor(237,42,173,7);
  flame->palette->setColor(238,51,167,9);
  flame->palette->setColor(239,60,162,11);
  flame->palette->setColor(240,69,156,13);
  flame->palette->setColor(241,79,150,16);
  flame->palette->setColor(242,88,144,18);
  flame->palette->setColor(243,97,138,20);
  flame->palette->setColor(244,106,133,22);
  flame->palette->setColor(245,116,127,25);
  flame->palette->setColor(246,125,121,27);
  flame->palette->setColor(247,134,115,29);
  flame->palette->setColor(248,143,110,31);
  flame->palette->setColor(249,153,104,34);
  flame->palette->setColor(250,162,98,36);
  flame->palette->setColor(251,171,92,38);
  flame->palette->setColor(252,180,86,40);
  flame->palette->setColor(253,190,81,43);
  flame->palette->setColor(254,199,75,45);
  flame->palette->setColor(255,99,174,159);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=6.3f;
  flame->xForms[0]->color=0.96792f;
  flame->xForms[0]->colorSymmetry=0.96251f;
  flame->xForms[0]->coeff00=-1.0f;
  flame->xForms[0]->coeff01=-0.0f;
  flame->xForms[0]->coeff10=0.0f;
  flame->xForms[0]->coeff11=-1.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=9.37f;
  flame->xForms[1]->color=0.11451f;
  flame->xForms[1]->colorSymmetry=1.0f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=-1.0f;
  flame->xForms[1]->coeff10=1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.38446f;
  flame->xForms[2]->color=0.54067f;
  flame->xForms[2]->colorSymmetry=0.0f;
  flame->xForms[2]->coeff00=0.0f;
  flame->xForms[2]->coeff01=-1.0f;
  flame->xForms[2]->coeff10=1.0f;
  flame->xForms[2]->coeff11=0.0f;
  flame->xForms[2]->coeff20=2.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new Linear3DFunc(), 1.0f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.21267f;
  flame->xForms[3]->color=0.90259f;
  flame->xForms[3]->colorSymmetry=0.0f;
  flame->xForms[3]->coeff00=0.0f;
  flame->xForms[3]->coeff01=-1.0f;
  flame->xForms[3]->coeff10=1.0f;
  flame->xForms[3]->coeff11=0.0f;
  flame->xForms[3]->coeff20=-2.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=1.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new Linear3DFunc(), 1.0f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.71771f;
  flame->xForms[4]->color=0.71908f;
  flame->xForms[4]->colorSymmetry=0.0f;
  flame->xForms[4]->coeff00=0.08027f;
  flame->xForms[4]->coeff01=-0.3437f;
  flame->xForms[4]->coeff10=0.3437f;
  flame->xForms[4]->coeff11=0.08027f;
  flame->xForms[4]->coeff20=-0.15213f;
  flame->xForms[4]->coeff21=-0.21345f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.0f;
  flame->xForms[4]->postCoeff21=0.0f;
  {
    Variation *var=flame->xForms[4]->addVariation(new FlowerFunc(), 1.0f);
    var->setParameter("holes",0.4f);
    var->setParameter("petals",7.0f);
  }
  return flame;
}

// Filled pink 3D flower
Flame *createExample9Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=609;
  flame->height=343;
  flame->centreX=0.0f;
  flame->centreY=-0.05f;
  flame->pixelsPerUnit=103.0f;
  flame->camRoll=0.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=2.79f;
  flame->gamma=1.72f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=2.0f;
  flame->camPitch=30.0f;
  flame->camYaw=-12.0;
  flame->camPerspective=0.27f;
  flame->camZ=0.34f;
  flame->camDOF=1.0f;

  flame->palette->setColor(0,87,14,28);
  flame->palette->setColor(1,87,26,29);
  flame->palette->setColor(2,88,20,28);
  flame->palette->setColor(3,103,32,36);
  flame->palette->setColor(4,103,18,31);
  flame->palette->setColor(5,104,24,35);
  flame->palette->setColor(6,118,18,36);
  flame->palette->setColor(7,119,38,44);
  flame->palette->setColor(8,120,32,40);
  flame->palette->setColor(9,120,24,36);
  flame->palette->setColor(10,135,22,42);
  flame->palette->setColor(11,135,48,52);
  flame->palette->setColor(12,136,36,44);
  flame->palette->setColor(13,136,28,44);
  flame->palette->setColor(14,136,42,48);
  flame->palette->setColor(15,150,22,45);
  flame->palette->setColor(16,151,56,59);
  flame->palette->setColor(17,151,28,46);
  flame->palette->setColor(18,152,48,53);
  flame->palette->setColor(19,152,36,50);
  flame->palette->setColor(20,152,42,52);
  flame->palette->setColor(21,167,26,52);
  flame->palette->setColor(22,167,64,65);
  flame->palette->setColor(23,167,30,52);
  flame->palette->setColor(24,168,48,59);
  flame->palette->setColor(25,168,36,52);
  flame->palette->setColor(26,168,56,60);
  flame->palette->setColor(27,168,42,54);
  flame->palette->setColor(28,183,36,57);
  flame->palette->setColor(29,183,29,56);
  flame->palette->setColor(30,184,48,60);
  flame->palette->setColor(31,184,64,68);
  flame->palette->setColor(32,184,56,65);
  flame->palette->setColor(33,184,42,60);
  flame->palette->setColor(34,198,30,60);
  flame->palette->setColor(35,199,40,61);
  flame->palette->setColor(36,199,46,63);
  flame->palette->setColor(37,200,52,67);
  flame->palette->setColor(38,200,64,71);
  flame->palette->setColor(39,200,34,60);
  flame->palette->setColor(40,200,58,68);
  flame->palette->setColor(41,200,70,76);
  flame->palette->setColor(42,215,52,69);
  flame->palette->setColor(43,215,34,66);
  flame->palette->setColor(44,215,46,68);
  flame->palette->setColor(45,215,58,72);
  flame->palette->setColor(46,216,76,80);
  flame->palette->setColor(47,216,64,76);
  flame->palette->setColor(48,216,40,67);
  flame->palette->setColor(49,216,70,76);
  flame->palette->setColor(50,231,52,75);
  flame->palette->setColor(51,231,37,69);
  flame->palette->setColor(52,231,64,77);
  flame->palette->setColor(53,231,58,76);
  flame->palette->setColor(54,232,76,84);
  flame->palette->setColor(55,232,84,86);
  flame->palette->setColor(56,232,44,70);
  flame->palette->setColor(57,232,70,81);
  flame->palette->setColor(58,246,38,75);
  flame->palette->setColor(59,249,44,76);
  flame->palette->setColor(60,250,76,91);
  flame->palette->setColor(61,250,64,86);
  flame->palette->setColor(62,250,52,81);
  flame->palette->setColor(63,250,92,98);
  flame->palette->setColor(64,250,84,94);
  flame->palette->setColor(65,250,70,87);
  flame->palette->setColor(66,250,58,84);
  flame->palette->setColor(67,250,98,101);
  flame->palette->setColor(68,252,132,151);
  flame->palette->setColor(69,252,148,158);
  flame->palette->setColor(70,252,104,126);
  flame->palette->setColor(71,252,120,134);
  flame->palette->setColor(72,252,164,166);
  flame->palette->setColor(73,252,92,120);
  flame->palette->setColor(74,252,76,110);
  flame->palette->setColor(75,252,65,100);
  flame->palette->setColor(76,252,57,100);
  flame->palette->setColor(77,252,140,152);
  flame->palette->setColor(78,252,156,160);
  flame->palette->setColor(79,252,112,128);
  flame->palette->setColor(80,252,84,112);
  flame->palette->setColor(81,252,132,134);
  flame->palette->setColor(82,252,172,188);
  flame->palette->setColor(83,252,189,196);
  flame->palette->setColor(84,252,126,136);
  flame->palette->setColor(85,252,98,120);
  flame->palette->setColor(86,252,104,110);
  flame->palette->setColor(87,252,45,84);
  flame->palette->setColor(88,252,70,102);
  flame->palette->setColor(89,252,149,172);
  flame->palette->setColor(90,252,105,140);
  flame->palette->setColor(91,252,121,149);
  flame->palette->setColor(92,252,164,181);
  flame->palette->setColor(93,252,180,189);
  flame->palette->setColor(94,12,10,6);
  flame->palette->setColor(95,20,14,12);
  flame->palette->setColor(96,28,16,13);
  flame->palette->setColor(97,36,26,20);
  flame->palette->setColor(98,41,22,20);
  flame->palette->setColor(99,44,27,21);
  flame->palette->setColor(100,55,28,26);
  flame->palette->setColor(101,55,22,20);
  flame->palette->setColor(102,58,34,28);
  flame->palette->setColor(103,60,38,30);
  flame->palette->setColor(104,60,46,36);
  flame->palette->setColor(105,70,38,35);
  flame->palette->setColor(106,71,32,29);
  flame->palette->setColor(107,73,44,36);
  flame->palette->setColor(108,76,50,42);
  flame->palette->setColor(109,76,58,44);
  flame->palette->setColor(110,87,44,39);
  flame->palette->setColor(111,87,38,36);
  flame->palette->setColor(112,88,52,44);
  flame->palette->setColor(113,92,62,52);
  flame->palette->setColor(114,92,58,48);
  flame->palette->setColor(115,92,70,52);
  flame->palette->setColor(116,102,58,51);
  flame->palette->setColor(117,103,52,45);
  flame->palette->setColor(118,103,44,43);
  flame->palette->setColor(119,103,38,38);
  flame->palette->setColor(120,105,64,53);
  flame->palette->setColor(121,108,74,60);
  flame->palette->setColor(122,108,70,60);
  flame->palette->setColor(123,118,65,56);
  flame->palette->setColor(124,118,70,60);
  flame->palette->setColor(125,119,52,50);
  flame->palette->setColor(126,119,44,44);
  flame->palette->setColor(127,119,58,52);
  flame->palette->setColor(128,122,75,62);
  flame->palette->setColor(129,124,86,68);
  flame->palette->setColor(130,124,82,68);
  flame->palette->setColor(131,134,77,66);
  flame->palette->setColor(132,135,64,59);
  flame->palette->setColor(133,135,56,53);
  flame->palette->setColor(134,135,70,60);
  flame->palette->setColor(135,137,84,70);
  flame->palette->setColor(136,140,90,76);
  flame->palette->setColor(137,140,98,76);
  flame->palette->setColor(138,150,85,73);
  flame->palette->setColor(139,151,76,68);
  flame->palette->setColor(140,151,64,60);
  flame->palette->setColor(141,152,92,77);
  flame->palette->setColor(142,152,70,64);
  flame->palette->setColor(143,156,102,83);
  flame->palette->setColor(144,156,98,83);
  flame->palette->setColor(145,164,110,84);
  flame->palette->setColor(146,164,102,84);
  flame->palette->setColor(147,166,93,79);
  flame->palette->setColor(148,166,98,84);
  flame->palette->setColor(149,167,84,75);
  flame->palette->setColor(150,167,70,68);
  flame->palette->setColor(151,168,76,69);
  flame->palette->setColor(152,175,104,89);
  flame->palette->setColor(153,179,111,92);
  flame->palette->setColor(154,180,119,93);
  flame->palette->setColor(155,180,126,100);
  flame->palette->setColor(156,183,76,75);
  flame->palette->setColor(157,183,92,82);
  flame->palette->setColor(158,183,98,84);
  flame->palette->setColor(159,183,70,69);
  flame->palette->setColor(160,184,84,76);
  flame->palette->setColor(161,188,118,100);
  flame->palette->setColor(162,188,104,89);
  flame->palette->setColor(163,188,112,96);
  flame->palette->setColor(164,196,131,101);
  flame->palette->setColor(165,198,113,97);
  flame->palette->setColor(166,199,104,91);
  flame->palette->setColor(167,199,120,102);
  flame->palette->setColor(168,199,84,81);
  flame->palette->setColor(169,199,98,86);
  flame->palette->setColor(170,200,76,76);
  flame->palette->setColor(171,200,92,84);
  flame->palette->setColor(172,203,126,107);
  flame->palette->setColor(173,204,138,108);
  flame->palette->setColor(174,204,130,108);
  flame->palette->setColor(175,214,121,103);
  flame->palette->setColor(176,214,126,108);
  flame->palette->setColor(177,215,104,92);
  flame->palette->setColor(178,215,112,98);
  flame->palette->setColor(179,216,132,112);
  flame->palette->setColor(180,216,92,87);
  flame->palette->setColor(181,216,84,84);
  flame->palette->setColor(182,216,98,92);
  flame->palette->setColor(183,219,147,116);
  flame->palette->setColor(184,219,138,115);
  flame->palette->setColor(185,220,154,116);
  flame->palette->setColor(186,230,133,114);
  flame->palette->setColor(187,231,120,105);
  flame->palette->setColor(188,231,140,119);
  flame->palette->setColor(189,231,112,100);
  flame->palette->setColor(190,231,126,108);
  flame->palette->setColor(191,232,104,97);
  flame->palette->setColor(192,232,92,92);
  flame->palette->setColor(193,232,98,92);
  flame->palette->setColor(194,233,155,122);
  flame->palette->setColor(195,235,147,123);
  flame->palette->setColor(196,242,163,126);
  flame->palette->setColor(197,248,148,127);
  flame->palette->setColor(198,248,141,121);
  flame->palette->setColor(199,249,104,100);
  flame->palette->setColor(200,249,120,108);
  flame->palette->setColor(201,250,132,117);
  flame->palette->setColor(202,250,112,108);
  flame->palette->setColor(203,250,126,114);
  flame->palette->setColor(204,251,156,131);
  flame->palette->setColor(205,252,195,163);
  flame->palette->setColor(206,252,227,187);
  flame->palette->setColor(207,252,179,148);
  flame->palette->setColor(208,252,211,171);
  flame->palette->setColor(209,252,244,203);
  flame->palette->setColor(210,252,180,174);
  flame->palette->setColor(211,252,196,191);
  flame->palette->setColor(212,252,228,215);
  flame->palette->setColor(213,252,212,198);
  flame->palette->setColor(214,252,244,229);
  flame->palette->setColor(215,252,171,140);
  flame->palette->setColor(216,252,203,163);
  flame->palette->setColor(217,252,235,187);
  flame->palette->setColor(218,252,188,159);
  flame->palette->setColor(219,252,172,167);
  flame->palette->setColor(220,252,188,175);
  flame->palette->setColor(221,252,164,138);
  flame->palette->setColor(222,252,220,185);
  flame->palette->setColor(223,252,204,191);
  flame->palette->setColor(224,252,237,213);
  flame->palette->setColor(225,252,221,197);
  flame->palette->setColor(226,252,148,142);
  flame->palette->setColor(227,252,197,172);
  flame->palette->setColor(228,252,229,197);
  flame->palette->setColor(229,252,181,156);
  flame->palette->setColor(230,252,245,212);
  flame->palette->setColor(231,252,165,149);
  flame->palette->setColor(232,252,120,118);
  flame->palette->setColor(233,252,140,134);
  flame->palette->setColor(234,252,157,141);
  flame->palette->setColor(235,252,172,149);
  flame->palette->setColor(236,252,212,181);
  flame->palette->setColor(237,252,213,212);
  flame->palette->setColor(238,252,204,174);
  flame->palette->setColor(239,252,236,199);
  flame->palette->setColor(240,252,251,203);
  flame->palette->setColor(241,252,253,216);
  flame->palette->setColor(242,252,254,238);
  flame->palette->setColor(243,7,3,4);
  flame->palette->setColor(244,22,6,7);
  flame->palette->setColor(245,22,10,12);
  flame->palette->setColor(246,39,6,12);
  flame->palette->setColor(247,40,16,17);
  flame->palette->setColor(248,40,10,12);
  flame->palette->setColor(249,55,16,20);
  flame->palette->setColor(250,55,10,18);
  flame->palette->setColor(251,70,10,20);
  flame->palette->setColor(252,71,20,25);
  flame->palette->setColor(253,71,26,28);
  flame->palette->setColor(254,72,14,22);
  flame->palette->setColor(255,87,32,34);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=0.42488f;
  flame->xForms[0]->color=0.0f;
  flame->xForms[0]->colorSymmetry=0.0f;
  flame->xForms[0]->coeff00=1.0f;
  flame->xForms[0]->coeff01=0.0f;
  flame->xForms[0]->coeff10=0.0f;
  flame->xForms[0]->coeff11=1.0f;
  flame->xForms[0]->coeff20=0.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new GaussianBlurFunc(), 0.71314f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=39.03f;
  flame->xForms[1]->color=0.33f;
  flame->xForms[1]->colorSymmetry=0.0f;
  flame->xForms[1]->coeff00=-1.25f;
  flame->xForms[1]->coeff01=-1.2f;
  flame->xForms[1]->coeff10=1.2f;
  flame->xForms[1]->coeff11=-1.25f;
  flame->xForms[1]->coeff20=-0.29857f;
  flame->xForms[1]->coeff21=0.23665f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Linear3DFunc(), 1.0f);
  {
    Variation *var=flame->xForms[1]->addVariation(new EpispiralWFFunc(), -0.00825476f);
    var->setParameter("waves",4.0f);
  }
  flame->xForms[1]->addVariation(new ZTranslateFunc(), 0.1927f);
  flame->xForms[1]->addVariation(new ZScaleFunc(), 0.0000095f);
  {
    Variation *var=flame->xForms[1]->addVariation(new PieFunc(), 0.03857f);
    var->setParameter("slices",6.0f);
    var->setParameter("rotation",0.0f);
    var->setParameter("thickness",0.5f);
  }
  flame->xForms[1]->addVariation(new CrossFunc(), 0.08683f);
  {
    Variation *var=flame->xForms[1]->addVariation(new Waves4WFFunc(), 0.04832f);
    var->setParameter("scalex",1.3f);
    var->setParameter("scaley",0.60796f);
    var->setParameter("freqx",1.16f);
    var->setParameter("freqy",2.26f);
    var->setParameter("use_cos_x",1.0f);
    var->setParameter("use_cos_y",0.0f);
    var->setParameter("dampx",0.0f);
    var->setParameter("dampy",0.0f);
  }
  flame->xForms[1]->addVariation(new CrossFunc(), 0.01303f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.26718f;
  flame->xForms[2]->color=0.0f;
  flame->xForms[2]->colorSymmetry=0.0f;
  flame->xForms[2]->coeff00=1.0f;
  flame->xForms[2]->coeff01=0.0f;
  flame->xForms[2]->coeff10=0.0f;
  flame->xForms[2]->coeff11=1.0f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.21089f;
  flame->xForms[2]->postCoeff21=-0.23974f;
  flame->xForms[2]->addVariation(new GaussianBlurFunc(), 0.71801f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.20038f;
  flame->xForms[3]->color=0.0f;
  flame->xForms[3]->colorSymmetry=0.0f;
  flame->xForms[3]->coeff00=1.0f;
  flame->xForms[3]->coeff01=0.0f;
  flame->xForms[3]->coeff10=0.0f;
  flame->xForms[3]->coeff11=1.0f;
  flame->xForms[3]->coeff20=0.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=1.0f;
  flame->xForms[3]->postCoeff20=0.07588f;
  flame->xForms[3]->postCoeff21=-0.1213f;
  flame->xForms[3]->addVariation(new GaussianBlurFunc(), 0.68014f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=1.45f;
  flame->xForms[4]->color=0.0f;
  flame->xForms[4]->colorSymmetry=0.88159f;
  flame->xForms[4]->coeff00=1.0f;
  flame->xForms[4]->coeff01=0.0f;
  flame->xForms[4]->coeff10=0.0f;
  flame->xForms[4]->coeff11=1.0f;
  flame->xForms[4]->coeff20=0.0f;
  flame->xForms[4]->coeff21=0.0f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.04818f;
  flame->xForms[4]->postCoeff21=0.06013f;
  flame->xForms[4]->addVariation(new BubbleFunc(), 0.16796f);
  flame->xForms[4]->addVariation(new ZConeFunc(), 0.50124f);
  {
    Variation *var=flame->xForms[4]->addVariation(new FlowerFunc(), 0.06002f);
    var->setParameter("holes",0.4f);
    var->setParameter("petals",7.0f);
  }
  // final xForm
  hostMalloc((void**)&flame->finalXForm, sizeof(XForm));
  flame->finalXForm->init();
  flame->finalXForm->weight=0.0f;
  flame->finalXForm->color=0.0f;
  flame->finalXForm->colorSymmetry=0.0f;
  flame->finalXForm->coeff00=1.0f;
  flame->finalXForm->coeff01=0.0f;
  flame->finalXForm->coeff10=0.0f;
  flame->finalXForm->coeff11=1.0f;
  flame->finalXForm->coeff20=0.0f;
  flame->finalXForm->coeff21=0.0f;
  flame->finalXForm->postCoeff00=1.0f;
  flame->finalXForm->postCoeff01=0.0f;
  flame->finalXForm->postCoeff10=0.0f;
  flame->finalXForm->postCoeff11=1.0f;
  flame->finalXForm->postCoeff20=0.0f;
  flame->finalXForm->postCoeff21=0.0f;
  flame->finalXForm->addVariation(new ZScaleFunc(), 0.24861f);
  {
    Variation *var=flame->finalXForm->addVariation(new Julia3DFunc(), 1.0f);
    var->setParameter("power",-4.0f);
  }
  return flame;
}

// "Ritual"
Flame *createExample10Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=779;
  flame->height=438;
  flame->centreX=-0.2f;
  flame->centreY=0.15f;
  flame->pixelsPerUnit=320.6f;
  flame->camRoll=0.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=1.0f;
  flame->sampleDensity=800.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=1.75f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=1.0f;
  flame->camPitch=49.0f;
  flame->camYaw=122.0;
  flame->camPerspective=0.31f;
  flame->camZ=0.0f;
  flame->camDOF=0.09f;

  flame->palette->setColor(0,55,0,3);
  flame->palette->setColor(1,45,0,4);
  flame->palette->setColor(2,39,1,5);
  flame->palette->setColor(3,38,8,6);
  flame->palette->setColor(4,41,11,7);
  flame->palette->setColor(5,44,14,8);
  flame->palette->setColor(6,52,21,10);
  flame->palette->setColor(7,65,31,12);
  flame->palette->setColor(8,75,41,14);
  flame->palette->setColor(9,89,51,19);
  flame->palette->setColor(10,117,69,35);
  flame->palette->setColor(11,132,76,43);
  flame->palette->setColor(12,147,84,52);
  flame->palette->setColor(13,154,84,54);
  flame->palette->setColor(14,161,85,57);
  flame->palette->setColor(15,175,86,59);
  flame->palette->setColor(16,186,85,59);
  flame->palette->setColor(17,196,85,59);
  flame->palette->setColor(18,204,86,62);
  flame->palette->setColor(19,211,84,76);
  flame->palette->setColor(20,213,84,79);
  flame->palette->setColor(21,215,84,82);
  flame->palette->setColor(22,220,86,88);
  flame->palette->setColor(23,223,89,93);
  flame->palette->setColor(24,226,92,99);
  flame->palette->setColor(25,228,93,102);
  flame->palette->setColor(26,232,98,109);
  flame->palette->setColor(27,232,102,110);
  flame->palette->setColor(28,233,106,112);
  flame->palette->setColor(29,233,113,115);
  flame->palette->setColor(30,236,127,119);
  flame->palette->setColor(31,238,141,125);
  flame->palette->setColor(32,241,158,133);
  flame->palette->setColor(33,243,175,142);
  flame->palette->setColor(34,242,186,154);
  flame->palette->setColor(35,248,208,164);
  flame->palette->setColor(36,246,208,164);
  flame->palette->setColor(37,245,209,164);
  flame->palette->setColor(38,241,206,160);
  flame->palette->setColor(39,238,197,153);
  flame->palette->setColor(40,232,186,143);
  flame->palette->setColor(41,228,178,135);
  flame->palette->setColor(42,210,150,123);
  flame->palette->setColor(43,207,143,119);
  flame->palette->setColor(44,205,136,116);
  flame->palette->setColor(45,197,122,108);
  flame->palette->setColor(46,187,108,98);
  flame->palette->setColor(47,180,95,85);
  flame->palette->setColor(48,172,81,71);
  flame->palette->setColor(49,167,69,63);
  flame->palette->setColor(50,161,59,53);
  flame->palette->setColor(51,156,50,50);
  flame->palette->setColor(52,153,49,49);
  flame->palette->setColor(53,150,49,49);
  flame->palette->setColor(54,149,54,49);
  flame->palette->setColor(55,153,61,49);
  flame->palette->setColor(56,156,70,48);
  flame->palette->setColor(57,159,76,54);
  flame->palette->setColor(58,168,89,56);
  flame->palette->setColor(59,169,92,55);
  flame->palette->setColor(60,171,96,55);
  flame->palette->setColor(61,169,99,56);
  flame->palette->setColor(62,165,100,55);
  flame->palette->setColor(63,161,100,56);
  flame->palette->setColor(64,150,98,53);
  flame->palette->setColor(65,140,94,53);
  flame->palette->setColor(66,132,88,48);
  flame->palette->setColor(67,130,80,43);
  flame->palette->setColor(68,130,72,37);
  flame->palette->setColor(69,129,64,30);
  flame->palette->setColor(70,126,53,24);
  flame->palette->setColor(71,127,45,20);
  flame->palette->setColor(72,124,34,18);
  flame->palette->setColor(73,119,28,21);
  flame->palette->setColor(74,116,22,26);
  flame->palette->setColor(75,117,18,31);
  flame->palette->setColor(76,122,15,32);
  flame->palette->setColor(77,131,14,33);
  flame->palette->setColor(78,143,12,32);
  flame->palette->setColor(79,156,14,32);
  flame->palette->setColor(80,171,13,28);
  flame->palette->setColor(81,181,18,29);
  flame->palette->setColor(82,186,23,32);
  flame->palette->setColor(83,190,31,39);
  flame->palette->setColor(84,193,41,42);
  flame->palette->setColor(85,192,49,46);
  flame->palette->setColor(86,194,54,48);
  flame->palette->setColor(87,192,60,48);
  flame->palette->setColor(88,187,61,43);
  flame->palette->setColor(89,181,65,36);
  flame->palette->setColor(90,174,64,31);
  flame->palette->setColor(91,167,65,31);
  flame->palette->setColor(92,161,67,29);
  flame->palette->setColor(93,151,69,29);
  flame->palette->setColor(94,144,68,29);
  flame->palette->setColor(95,141,66,27);
  flame->palette->setColor(96,135,61,26);
  flame->palette->setColor(97,126,58,24);
  flame->palette->setColor(98,117,51,21);
  flame->palette->setColor(99,104,44,19);
  flame->palette->setColor(100,93,37,16);
  flame->palette->setColor(101,80,32,13);
  flame->palette->setColor(102,70,26,11);
  flame->palette->setColor(103,65,18,8);
  flame->palette->setColor(104,65,11,6);
  flame->palette->setColor(105,66,8,6);
  flame->palette->setColor(106,70,5,4);
  flame->palette->setColor(107,70,4,3);
  flame->palette->setColor(108,71,4,3);
  flame->palette->setColor(109,72,6,3);
  flame->palette->setColor(110,73,9,7);
  flame->palette->setColor(111,74,15,11);
  flame->palette->setColor(112,82,24,17);
  flame->palette->setColor(113,94,39,27);
  flame->palette->setColor(114,111,55,38);
  flame->palette->setColor(115,128,69,47);
  flame->palette->setColor(116,145,83,57);
  flame->palette->setColor(117,162,96,63);
  flame->palette->setColor(118,178,107,72);
  flame->palette->setColor(119,185,115,80);
  flame->palette->setColor(120,194,120,85);
  flame->palette->setColor(121,202,132,92);
  flame->palette->setColor(122,211,144,99);
  flame->palette->setColor(123,217,148,105);
  flame->palette->setColor(124,221,148,113);
  flame->palette->setColor(125,222,149,117);
  flame->palette->setColor(126,225,148,119);
  flame->palette->setColor(127,219,140,121);
  flame->palette->setColor(128,211,125,116);
  flame->palette->setColor(129,199,113,112);
  flame->palette->setColor(130,189,106,106);
  flame->palette->setColor(131,165,81,91);
  flame->palette->setColor(132,155,71,87);
  flame->palette->setColor(133,146,62,83);
  flame->palette->setColor(134,137,51,81);
  flame->palette->setColor(135,129,41,80);
  flame->palette->setColor(136,123,36,79);
  flame->palette->setColor(137,117,31,78);
  flame->palette->setColor(138,89,23,63);
  flame->palette->setColor(139,76,19,54);
  flame->palette->setColor(140,63,16,45);
  flame->palette->setColor(141,54,14,39);
  flame->palette->setColor(142,45,13,34);
  flame->palette->setColor(143,44,12,33);
  flame->palette->setColor(144,43,12,33);
  flame->palette->setColor(145,43,12,32);
  flame->palette->setColor(146,44,12,32);
  flame->palette->setColor(147,49,12,34);
  flame->palette->setColor(148,53,11,34);
  flame->palette->setColor(149,57,10,35);
  flame->palette->setColor(150,64,9,31);
  flame->palette->setColor(151,72,9,27);
  flame->palette->setColor(152,79,9,26);
  flame->palette->setColor(153,87,9,26);
  flame->palette->setColor(154,115,16,22);
  flame->palette->setColor(155,132,24,24);
  flame->palette->setColor(156,149,32,26);
  flame->palette->setColor(157,162,41,32);
  flame->palette->setColor(158,175,50,39);
  flame->palette->setColor(159,181,53,40);
  flame->palette->setColor(160,187,57,42);
  flame->palette->setColor(161,200,61,44);
  flame->palette->setColor(162,213,62,41);
  flame->palette->setColor(163,218,72,33);
  flame->palette->setColor(164,220,78,31);
  flame->palette->setColor(165,223,84,30);
  flame->palette->setColor(166,217,87,31);
  flame->palette->setColor(167,212,91,32);
  flame->palette->setColor(168,208,89,32);
  flame->palette->setColor(169,204,88,33);
  flame->palette->setColor(170,184,74,31);
  flame->palette->setColor(171,167,66,29);
  flame->palette->setColor(172,151,59,27);
  flame->palette->setColor(173,136,53,24);
  flame->palette->setColor(174,121,47,21);
  flame->palette->setColor(175,112,45,19);
  flame->palette->setColor(176,104,44,18);
  flame->palette->setColor(177,90,37,15);
  flame->palette->setColor(178,81,28,13);
  flame->palette->setColor(179,68,19,13);
  flame->palette->setColor(180,67,27,22);
  flame->palette->setColor(181,67,35,31);
  flame->palette->setColor(182,75,50,42);
  flame->palette->setColor(183,83,65,54);
  flame->palette->setColor(184,86,72,59);
  flame->palette->setColor(185,90,79,65);
  flame->palette->setColor(186,112,94,82);
  flame->palette->setColor(187,124,100,84);
  flame->palette->setColor(188,136,107,87);
  flame->palette->setColor(189,151,116,90);
  flame->palette->setColor(190,167,125,93);
  flame->palette->setColor(191,177,131,94);
  flame->palette->setColor(192,188,137,96);
  flame->palette->setColor(193,203,149,99);
  flame->palette->setColor(194,213,156,102);
  flame->palette->setColor(195,223,142,95);
  flame->palette->setColor(196,218,128,84);
  flame->palette->setColor(197,214,114,74);
  flame->palette->setColor(198,210,106,68);
  flame->palette->setColor(199,207,99,63);
  flame->palette->setColor(200,206,88,50);
  flame->palette->setColor(201,205,86,39);
  flame->palette->setColor(202,205,91,33);
  flame->palette->setColor(203,207,93,34);
  flame->palette->setColor(204,209,96,35);
  flame->palette->setColor(205,208,100,39);
  flame->palette->setColor(206,208,105,44);
  flame->palette->setColor(207,208,105,43);
  flame->palette->setColor(208,208,105,43);
  flame->palette->setColor(209,207,108,42);
  flame->palette->setColor(210,205,112,45);
  flame->palette->setColor(211,204,124,53);
  flame->palette->setColor(212,206,133,58);
  flame->palette->setColor(213,209,142,63);
  flame->palette->setColor(214,210,146,66);
  flame->palette->setColor(215,212,151,70);
  flame->palette->setColor(216,215,157,73);
  flame->palette->setColor(217,218,162,74);
  flame->palette->setColor(218,213,161,75);
  flame->palette->setColor(219,205,152,71);
  flame->palette->setColor(220,198,144,68);
  flame->palette->setColor(221,193,138,66);
  flame->palette->setColor(222,188,132,64);
  flame->palette->setColor(223,175,120,60);
  flame->palette->setColor(224,159,109,56);
  flame->palette->setColor(225,146,101,51);
  flame->palette->setColor(226,132,92,46);
  flame->palette->setColor(227,107,79,36);
  flame->palette->setColor(228,95,71,32);
  flame->palette->setColor(229,84,63,29);
  flame->palette->setColor(230,78,58,27);
  flame->palette->setColor(231,73,54,25);
  flame->palette->setColor(232,59,43,19);
  flame->palette->setColor(233,46,32,15);
  flame->palette->setColor(234,31,14,7);
  flame->palette->setColor(235,31,11,4);
  flame->palette->setColor(236,31,8,2);
  flame->palette->setColor(237,34,7,2);
  flame->palette->setColor(238,37,7,3);
  flame->palette->setColor(239,51,9,4);
  flame->palette->setColor(240,65,10,6);
  flame->palette->setColor(241,77,9,6);
  flame->palette->setColor(242,88,8,7);
  flame->palette->setColor(243,107,7,9);
  flame->palette->setColor(244,110,7,8);
  flame->palette->setColor(245,114,8,8);
  flame->palette->setColor(246,117,6,7);
  flame->palette->setColor(247,121,7,7);
  flame->palette->setColor(248,120,8,8);
  flame->palette->setColor(249,117,8,7);
  flame->palette->setColor(250,108,6,7);
  flame->palette->setColor(251,100,4,7);
  flame->palette->setColor(252,92,3,7);
  flame->palette->setColor(253,86,2,6);
  flame->palette->setColor(254,80,2,5);
  flame->palette->setColor(255,69,0,3);

  flame->xFormCount=9;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=0.5f;
  flame->xForms[0]->color=0.0f;
  flame->xForms[0]->colorSymmetry=0.0f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=-1.0f;
  flame->xForms[0]->coeff10=1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=-1.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=0.5f;
  flame->xForms[1]->color=0.125f;
  flame->xForms[1]->colorSymmetry=1.0f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=-1.0f;
  flame->xForms[1]->coeff10=1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=1.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.5f;
  flame->xForms[2]->color=0.25f;
  flame->xForms[2]->colorSymmetry=0.0f;
  flame->xForms[2]->coeff00=0.0f;
  flame->xForms[2]->coeff01=-1.0f;
  flame->xForms[2]->coeff10=1.0f;
  flame->xForms[2]->coeff11=0.0f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.5f;
  flame->xForms[3]->color=0.375f;
  flame->xForms[3]->colorSymmetry=0.58f;
  flame->xForms[3]->coeff00=0.0f;
  flame->xForms[3]->coeff01=-1.0f;
  flame->xForms[3]->coeff10=1.0f;
  flame->xForms[3]->coeff11=0.0f;
  flame->xForms[3]->coeff20=0.0f;
  flame->xForms[3]->coeff21=-1.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=1.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.5f;
  flame->xForms[4]->color=0.5f;
  flame->xForms[4]->colorSymmetry=0.0f;
  flame->xForms[4]->coeff00=0.0f;
  flame->xForms[4]->coeff01=-1.0f;
  flame->xForms[4]->coeff10=1.0f;
  flame->xForms[4]->coeff11=0.0f;
  flame->xForms[4]->coeff20=-1.0f;
  flame->xForms[4]->coeff21=-1.0f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.0f;
  flame->xForms[4]->postCoeff21=0.0f;
  flame->xForms[4]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm6
  hostMalloc((void**)&flame->xForms[5], sizeof(XForm));
  flame->xForms[5]->init();
  flame->xForms[5]->weight=0.5f;
  flame->xForms[5]->color=0.625f;
  flame->xForms[5]->colorSymmetry=-0.51f;
  flame->xForms[5]->coeff00=0.0f;
  flame->xForms[5]->coeff01=-1.0f;
  flame->xForms[5]->coeff10=1.0f;
  flame->xForms[5]->coeff11=0.0f;
  flame->xForms[5]->coeff20=-1.0f;
  flame->xForms[5]->coeff21=0.0f;
  flame->xForms[5]->postCoeff00=1.0f;
  flame->xForms[5]->postCoeff01=0.0f;
  flame->xForms[5]->postCoeff10=0.0f;
  flame->xForms[5]->postCoeff11=1.0f;
  flame->xForms[5]->postCoeff20=0.0f;
  flame->xForms[5]->postCoeff21=0.0f;
  flame->xForms[5]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm7
  hostMalloc((void**)&flame->xForms[6], sizeof(XForm));
  flame->xForms[6]->init();
  flame->xForms[6]->weight=0.4f;
  flame->xForms[6]->color=0.75f;
  flame->xForms[6]->colorSymmetry=0.41f;
  flame->xForms[6]->coeff00=0.0f;
  flame->xForms[6]->coeff01=-1.0f;
  flame->xForms[6]->coeff10=-0.01473f;
  flame->xForms[6]->coeff11=0.92275f;
  flame->xForms[6]->coeff20=1.0f;
  flame->xForms[6]->coeff21=1.0f;
  flame->xForms[6]->postCoeff00=1.0f;
  flame->xForms[6]->postCoeff01=0.0f;
  flame->xForms[6]->postCoeff10=0.0f;
  flame->xForms[6]->postCoeff11=1.0f;
  flame->xForms[6]->postCoeff20=0.0f;
  flame->xForms[6]->postCoeff21=0.0f;
  flame->xForms[6]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm8
  hostMalloc((void**)&flame->xForms[7], sizeof(XForm));
  flame->xForms[7]->init();
  flame->xForms[7]->weight=0.5f;
  flame->xForms[7]->color=0.875f;
  flame->xForms[7]->colorSymmetry=0.64f;
  flame->xForms[7]->coeff00=0.0f;
  flame->xForms[7]->coeff01=-1.0f;
  flame->xForms[7]->coeff10=-0.00574282f;
  flame->xForms[7]->coeff11=0.01502f;
  flame->xForms[7]->coeff20=0.0f;
  flame->xForms[7]->coeff21=1.0f;
  flame->xForms[7]->postCoeff00=1.0f;
  flame->xForms[7]->postCoeff01=0.0f;
  flame->xForms[7]->postCoeff10=0.0f;
  flame->xForms[7]->postCoeff11=1.0f;
  flame->xForms[7]->postCoeff20=0.0f;
  flame->xForms[7]->postCoeff21=0.0f;
  flame->xForms[7]->addVariation(new Spherical3DFunc(), 1.0f);
  // xForm9
  hostMalloc((void**)&flame->xForms[8], sizeof(XForm));
  flame->xForms[8]->init();
  flame->xForms[8]->weight=0.5f;
  flame->xForms[8]->color=1.0f;
  flame->xForms[8]->colorSymmetry=-0.73f;
  flame->xForms[8]->coeff00=0.0f;
  flame->xForms[8]->coeff01=-1.0f;
  flame->xForms[8]->coeff10=-0.00873908f;
  flame->xForms[8]->coeff11=0.0f;
  flame->xForms[8]->coeff20=-1.0f;
  flame->xForms[8]->coeff21=1.0f;
  flame->xForms[8]->postCoeff00=1.0f;
  flame->xForms[8]->postCoeff01=0.0f;
  flame->xForms[8]->postCoeff10=0.0f;
  flame->xForms[8]->postCoeff11=1.0f;
  flame->xForms[8]->postCoeff20=0.0f;
  flame->xForms[8]->postCoeff21=0.0f;
  flame->xForms[8]->addVariation(new Spherical3DFunc(), 1.0f);

  return flame;
}
#ifdef fuck
Flame *createExample11Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=779;
  flame->height=438;
  flame->centreX=-0.55f;
  flame->centreY=-0.2f;
  flame->pixelsPerUnit=85.18f;
  flame->camRoll=0.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.5f;
  flame->sampleDensity=800.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=4.0f;
  flame->gamma=2.6f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=3.01f;
  flame->camPitch=-141.0f;
  flame->camYaw=62.0;
  flame->camPerspective=0.22f;
  flame->camZ=-0.78f;
  flame->camDOF=0.28f;

  flame->palette->setColor(0,32,68,85);
  flame->palette->setColor(1,30,65,82);
  flame->palette->setColor(2,27,61,78);
  flame->palette->setColor(3,25,58,75);
  flame->palette->setColor(4,42,168,72);
  flame->palette->setColor(5,45,164,76);
  flame->palette->setColor(6,48,161,80);
  flame->palette->setColor(7,51,157,84);
  flame->palette->setColor(8,54,153,87);
  flame->palette->setColor(9,57,149,91);
  flame->palette->setColor(10,60,146,95);
  flame->palette->setColor(11,63,142,99);
  flame->palette->setColor(12,66,138,103);
  flame->palette->setColor(13,69,135,107);
  flame->palette->setColor(14,72,131,110);
  flame->palette->setColor(15,75,127,114);
  flame->palette->setColor(16,78,124,118);
  flame->palette->setColor(17,81,120,122);
  flame->palette->setColor(18,84,116,126);
  flame->palette->setColor(19,87,112,130);
  flame->palette->setColor(20,90,109,134);
  flame->palette->setColor(21,93,105,137);
  flame->palette->setColor(22,96,101,141);
  flame->palette->setColor(23,99,98,145);
  flame->palette->setColor(24,102,94,149);
  flame->palette->setColor(25,105,90,153);
  flame->palette->setColor(26,107,87,157);
  flame->palette->setColor(27,110,83,160);
  flame->palette->setColor(28,113,79,164);
  flame->palette->setColor(29,116,75,168);
  flame->palette->setColor(30,119,72,172);
  flame->palette->setColor(31,122,68,176);
  flame->palette->setColor(32,125,64,180);
  flame->palette->setColor(33,128,61,183);
  flame->palette->setColor(34,131,57,187);
  flame->palette->setColor(35,134,53,191);
  flame->palette->setColor(36,137,50,195);
  flame->palette->setColor(37,140,46,199);
  flame->palette->setColor(38,143,42,203);
  flame->palette->setColor(39,146,38,207);
  flame->palette->setColor(40,149,35,210);
  flame->palette->setColor(41,152,31,214);
  flame->palette->setColor(42,155,27,218);
  flame->palette->setColor(43,158,24,222);
  flame->palette->setColor(44,161,20,226);
  flame->palette->setColor(45,164,16,230);
  flame->palette->setColor(46,167,12,233);
  flame->palette->setColor(47,169,11,234);
  flame->palette->setColor(48,169,16,229);
  flame->palette->setColor(49,168,20,223);
  flame->palette->setColor(50,168,25,218);
  flame->palette->setColor(51,168,29,212);
  flame->palette->setColor(52,168,33,207);
  flame->palette->setColor(53,167,38,201);
  flame->palette->setColor(54,167,42,196);
  flame->palette->setColor(55,167,47,190);
  flame->palette->setColor(56,166,51,185);
  flame->palette->setColor(57,166,55,179);
  flame->palette->setColor(58,166,60,174);
  flame->palette->setColor(59,166,64,168);
  flame->palette->setColor(60,165,68,163);
  flame->palette->setColor(61,165,73,157);
  flame->palette->setColor(62,165,77,152);
  flame->palette->setColor(63,164,82,146);
  flame->palette->setColor(64,164,86,141);
  flame->palette->setColor(65,164,90,135);
  flame->palette->setColor(66,164,95,130);
  flame->palette->setColor(67,163,99,124);
  flame->palette->setColor(68,163,104,119);
  flame->palette->setColor(69,163,108,113);
  flame->palette->setColor(70,162,112,107);
  flame->palette->setColor(71,162,117,102);
  flame->palette->setColor(72,162,121,96);
  flame->palette->setColor(73,162,125,91);
  flame->palette->setColor(74,161,130,85);
  flame->palette->setColor(75,161,134,80);
  flame->palette->setColor(76,161,139,74);
  flame->palette->setColor(77,160,143,69);
  flame->palette->setColor(78,160,147,63);
  flame->palette->setColor(79,160,152,58);
  flame->palette->setColor(80,160,156,52);
  flame->palette->setColor(81,159,160,47);
  flame->palette->setColor(82,159,165,41);
  flame->palette->setColor(83,159,169,36);
  flame->palette->setColor(84,159,174,30);
  flame->palette->setColor(85,158,178,25);
  flame->palette->setColor(86,158,182,19);
  flame->palette->setColor(87,158,187,14);
  flame->palette->setColor(88,157,191,8);
  flame->palette->setColor(89,157,196,3);
  flame->palette->setColor(90,155,194,2);
  flame->palette->setColor(91,151,190,4);
  flame->palette->setColor(92,147,187,6);
  flame->palette->setColor(93,144,183,8);
  flame->palette->setColor(94,140,179,9);
  flame->palette->setColor(95,136,175,11);
  flame->palette->setColor(96,133,171,13);
  flame->palette->setColor(97,129,167,15);
  flame->palette->setColor(98,126,163,16);
  flame->palette->setColor(99,122,159,18);
  flame->palette->setColor(100,118,155,20);
  flame->palette->setColor(101,115,151,22);
  flame->palette->setColor(102,111,147,24);
  flame->palette->setColor(103,107,143,25);
  flame->palette->setColor(104,104,139,27);
  flame->palette->setColor(105,100,135,29);
  flame->palette->setColor(106,96,131,31);
  flame->palette->setColor(107,93,127,32);
  flame->palette->setColor(108,89,124,34);
  flame->palette->setColor(109,86,120,36);
  flame->palette->setColor(110,82,116,38);
  flame->palette->setColor(111,78,112,40);
  flame->palette->setColor(112,75,108,41);
  flame->palette->setColor(113,71,104,43);
  flame->palette->setColor(114,67,100,45);
  flame->palette->setColor(115,64,96,47);
  flame->palette->setColor(116,60,92,49);
  flame->palette->setColor(117,56,88,50);
  flame->palette->setColor(118,53,84,52);
  flame->palette->setColor(119,49,80,54);
  flame->palette->setColor(120,46,76,56);
  flame->palette->setColor(121,42,72,57);
  flame->palette->setColor(122,38,68,59);
  flame->palette->setColor(123,35,64,61);
  flame->palette->setColor(124,31,61,63);
  flame->palette->setColor(125,27,57,65);
  flame->palette->setColor(126,24,53,66);
  flame->palette->setColor(127,20,49,68);
  flame->palette->setColor(128,17,45,70);
  flame->palette->setColor(129,13,41,72);
  flame->palette->setColor(130,9,37,73);
  flame->palette->setColor(131,6,33,75);
  flame->palette->setColor(132,2,29,77);
  flame->palette->setColor(133,6,31,81);
  flame->palette->setColor(134,9,32,84);
  flame->palette->setColor(135,13,34,88);
  flame->palette->setColor(136,17,35,92);
  flame->palette->setColor(137,21,37,95);
  flame->palette->setColor(138,24,38,99);
  flame->palette->setColor(139,28,40,103);
  flame->palette->setColor(140,32,42,106);
  flame->palette->setColor(141,36,43,110);
  flame->palette->setColor(142,39,45,114);
  flame->palette->setColor(143,43,46,117);
  flame->palette->setColor(144,47,48,121);
  flame->palette->setColor(145,50,49,125);
  flame->palette->setColor(146,54,51,129);
  flame->palette->setColor(147,58,53,132);
  flame->palette->setColor(148,62,54,136);
  flame->palette->setColor(149,65,56,140);
  flame->palette->setColor(150,69,57,143);
  flame->palette->setColor(151,73,59,147);
  flame->palette->setColor(152,77,60,151);
  flame->palette->setColor(153,80,62,154);
  flame->palette->setColor(154,84,64,158);
  flame->palette->setColor(155,88,65,162);
  flame->palette->setColor(156,91,67,165);
  flame->palette->setColor(157,95,68,169);
  flame->palette->setColor(158,99,70,173);
  flame->palette->setColor(159,103,71,176);
  flame->palette->setColor(160,106,73,180);
  flame->palette->setColor(161,110,75,184);
  flame->palette->setColor(162,114,76,187);
  flame->palette->setColor(163,118,78,191);
  flame->palette->setColor(164,121,79,195);
  flame->palette->setColor(165,125,81,198);
  flame->palette->setColor(166,129,82,202);
  flame->palette->setColor(167,132,84,206);
  flame->palette->setColor(168,136,86,209);
  flame->palette->setColor(169,140,87,213);
  flame->palette->setColor(170,144,89,217);
  flame->palette->setColor(171,147,90,221);
  flame->palette->setColor(172,151,92,224);
  flame->palette->setColor(173,155,93,228);
  flame->palette->setColor(174,159,95,232);
  flame->palette->setColor(175,161,97,234);
  flame->palette->setColor(176,160,99,234);
  flame->palette->setColor(177,159,102,233);
  flame->palette->setColor(178,158,104,233);
  flame->palette->setColor(179,157,107,233);
  flame->palette->setColor(180,156,110,233);
  flame->palette->setColor(181,155,112,233);
  flame->palette->setColor(182,154,115,232);
  flame->palette->setColor(183,153,117,232);
  flame->palette->setColor(184,152,120,232);
  flame->palette->setColor(185,151,122,232);
  flame->palette->setColor(186,150,125,231);
  flame->palette->setColor(187,149,127,231);
  flame->palette->setColor(188,148,130,231);
  flame->palette->setColor(189,147,132,231);
  flame->palette->setColor(190,146,135,230);
  flame->palette->setColor(191,145,137,230);
  flame->palette->setColor(192,144,140,230);
  flame->palette->setColor(193,143,142,230);
  flame->palette->setColor(194,142,145,229);
  flame->palette->setColor(195,141,147,229);
  flame->palette->setColor(196,140,150,229);
  flame->palette->setColor(197,138,153,229);
  flame->palette->setColor(198,137,155,229);
  flame->palette->setColor(199,136,158,228);
  flame->palette->setColor(200,135,160,228);
  flame->palette->setColor(201,134,163,228);
  flame->palette->setColor(202,133,165,228);
  flame->palette->setColor(203,132,168,227);
  flame->palette->setColor(204,131,170,227);
  flame->palette->setColor(205,130,173,227);
  flame->palette->setColor(206,129,175,227);
  flame->palette->setColor(207,128,178,226);
  flame->palette->setColor(208,127,180,226);
  flame->palette->setColor(209,126,183,226);
  flame->palette->setColor(210,125,185,226);
  flame->palette->setColor(211,124,188,225);
  flame->palette->setColor(212,123,191,225);
  flame->palette->setColor(213,122,193,225);
  flame->palette->setColor(214,121,196,225);
  flame->palette->setColor(215,120,198,225);
  flame->palette->setColor(216,119,201,224);
  flame->palette->setColor(217,118,203,224);
  flame->palette->setColor(218,117,202,222);
  flame->palette->setColor(219,114,198,218);
  flame->palette->setColor(220,112,195,214);
  flame->palette->setColor(221,110,191,211);
  flame->palette->setColor(222,108,188,207);
  flame->palette->setColor(223,105,184,204);
  flame->palette->setColor(224,103,181,200);
  flame->palette->setColor(225,101,177,197);
  flame->palette->setColor(226,99,174,193);
  flame->palette->setColor(227,96,170,189);
  flame->palette->setColor(228,94,167,186);
  flame->palette->setColor(229,92,163,182);
  flame->palette->setColor(230,90,159,179);
  flame->palette->setColor(231,88,156,175);
  flame->palette->setColor(232,85,152,171);
  flame->palette->setColor(233,83,149,168);
  flame->palette->setColor(234,81,145,164);
  flame->palette->setColor(235,79,142,161);
  flame->palette->setColor(236,76,138,157);
  flame->palette->setColor(237,74,135,153);
  flame->palette->setColor(238,72,131,150);
  flame->palette->setColor(239,70,128,146);
  flame->palette->setColor(240,68,124,143);
  flame->palette->setColor(241,65,121,139);
  flame->palette->setColor(242,63,117,136);
  flame->palette->setColor(243,61,114,132);
  flame->palette->setColor(244,59,110,128);
  flame->palette->setColor(245,56,107,125);
  flame->palette->setColor(246,54,103,121);
  flame->palette->setColor(247,52,100,118);
  flame->palette->setColor(248,50,96,114);
  flame->palette->setColor(249,47,93,110);
  flame->palette->setColor(250,45,89,107);
  flame->palette->setColor(251,43,86,103);
  flame->palette->setColor(252,41,82,100);
  flame->palette->setColor(253,39,79,96);
  flame->palette->setColor(254,36,75,93);
  flame->palette->setColor(255,34,72,89);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=3.2f;
  flame->xForms[0]->color=0.99715f;
  flame->xForms[0]->colorSymmetry=0.9758f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=-1.0f;
  flame->xForms[0]->coeff10=1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  {
    Variation *var=flame->xForms[0]->addVariation(VARIATION_SPHERICAL3D_WF, 1.0f);
    var->setParameter("invert",1.0f);
    var->setParameter("exponent",2.0f);
  }
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=0.61189f;
  flame->xForms[1]->color=0.91617f;
  flame->xForms[1]->colorSymmetry=0.95827f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=-1.0f;
  flame->xForms[1]->coeff10=1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  {
    Variation *var=flame->xForms[1]->addVariation(VARIATION_SPHERICAL3D_WF, 1.0f);
    var->setParameter("invert",1.0f);
    var->setParameter("exponent",2.0f);
  }
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.5f;
  flame->xForms[2]->color=0.78999f;
  flame->xForms[2]->colorSymmetry=-1.0f;
  flame->xForms[2]->coeff00=1.0f;
  flame->xForms[2]->coeff01=0.0f;
  flame->xForms[2]->coeff10=0.0f;
  flame->xForms[2]->coeff11=1.0f;
  flame->xForms[2]->coeff20=0.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=5.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(VARIATION_ZTRANSLATE, 0.34254f);
  flame->xForms[2]->addVariation(VARIATION_CYLINDER, 0.18471f);
  flame->xForms[2]->addVariation(VARIATION_PRE_BLUR, 0.33299f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.5f;
  flame->xForms[3]->color=0.81f;
  flame->xForms[3]->colorSymmetry=-1.0f;
  flame->xForms[3]->coeff00=1.0f;
  flame->xForms[3]->coeff01=0.0f;
  flame->xForms[3]->coeff10=0.0f;
  flame->xForms[3]->coeff11=1.0f;
  flame->xForms[3]->coeff20=0.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=3.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(VARIATION_ZTRANSLATE, 0.36253f);
  flame->xForms[3]->addVariation(VARIATION_PRE_BLUR, 0.03321f);
  {
    Variation *var=flame->xForms[3]->addVariation(VARIATION_WEDGE_JULIA, 0.11784f);
    var->setParameter("power",7.0f);
    var->setParameter("dist",0.2f);
    var->setParameter("count",2.0f);
    var->setParameter("angle",0.3f);
  }
  flame->xForms[3]->addVariation(VARIATION_ZCONE, 0.12f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.1f;
  flame->xForms[4]->color=0.95464f;
  flame->xForms[4]->colorSymmetry=-1.0f;
  flame->xForms[4]->coeff00=1.0f;
  flame->xForms[4]->coeff01=0.0f;
  flame->xForms[4]->coeff10=0.0f;
  flame->xForms[4]->coeff11=1.0f;
  flame->xForms[4]->coeff20=0.0f;
  flame->xForms[4]->coeff21=0.0f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.3f;
  flame->xForms[4]->postCoeff21=0.0f;
  flame->xForms[4]->addVariation(VARIATION_ZTRANSLATE, 0.00900784f);
  flame->xForms[4]->addVariation(VARIATION_GAUSSIAN_BLUR, 0.00991991f);

  return flame;
}

#endif

#ifdef flame12
Flame *createExample12Flame() {
  Flame *flame;
  hostMalloc((void**)&flame,sizeof(Flame));
  flame->create();
  flame->width=777;
  flame->height=437;
  flame->centreX=0.0f;
  flame->centreY=0.0f;
  flame->pixelsPerUnit=84.98f;
  flame->camRoll=0.0f;
  flame->spatialOversample=1;
  flame->colorOversample=1;
  flame->spatialFilterRadius=0.0f;
  flame->sampleDensity=50.0f;
  flame->bgColorRed=0;
  flame->bgColorGreen=0;
  flame->bgColorBlue=0;
  flame->brightness=2.01f;
  flame->gamma=1.72f;
  flame->gammaThreshold=0.04f;
  flame->camZoom=2.4f;
  flame->camPitch=48.0f;
  flame->camYaw=23.0;
  flame->camPerspective=0.32f;
  flame->camZ=0.0f;
  flame->camDOF=0.16f;

  flame->palette->setColor(0,159,158,13);
  flame->palette->setColor(1,149,151,11);
  flame->palette->setColor(2,139,144,10);
  flame->palette->setColor(3,129,137,9);
  flame->palette->setColor(4,119,130,8);
  flame->palette->setColor(5,108,123,6);
  flame->palette->setColor(6,98,116,5);
  flame->palette->setColor(7,88,109,4);
  flame->palette->setColor(8,78,102,3);
  flame->palette->setColor(9,71,100,7);
  flame->palette->setColor(10,68,106,18);
  flame->palette->setColor(11,65,112,30);
  flame->palette->setColor(12,62,118,41);
  flame->palette->setColor(13,60,124,53);
  flame->palette->setColor(14,57,130,64);
  flame->palette->setColor(15,54,136,76);
  flame->palette->setColor(16,51,141,87);
  flame->palette->setColor(17,48,147,99);
  flame->palette->setColor(18,46,153,111);
  flame->palette->setColor(19,43,159,122);
  flame->palette->setColor(20,40,165,134);
  flame->palette->setColor(21,37,171,145);
  flame->palette->setColor(22,34,177,157);
  flame->palette->setColor(23,32,182,168);
  flame->palette->setColor(24,29,188,180);
  flame->palette->setColor(25,26,194,191);
  flame->palette->setColor(26,24,195,196);
  flame->palette->setColor(27,23,186,188);
  flame->palette->setColor(28,22,176,180);
  flame->palette->setColor(29,21,167,171);
  flame->palette->setColor(30,20,158,163);
  flame->palette->setColor(31,19,148,155);
  flame->palette->setColor(32,18,139,147);
  flame->palette->setColor(33,18,130,138);
  flame->palette->setColor(34,17,120,130);
  flame->palette->setColor(35,16,111,122);
  flame->palette->setColor(36,15,102,114);
  flame->palette->setColor(37,14,92,105);
  flame->palette->setColor(38,13,83,97);
  flame->palette->setColor(39,12,74,89);
  flame->palette->setColor(40,11,64,81);
  flame->palette->setColor(41,11,55,72);
  flame->palette->setColor(42,10,46,64);
  flame->palette->setColor(43,11,41,58);
  flame->palette->setColor(44,20,48,57);
  flame->palette->setColor(45,28,55,57);
  flame->palette->setColor(46,36,63,56);
  flame->palette->setColor(47,45,70,56);
  flame->palette->setColor(48,53,77,55);
  flame->palette->setColor(49,62,85,55);
  flame->palette->setColor(50,70,92,54);
  flame->palette->setColor(51,78,99,54);
  flame->palette->setColor(52,87,106,53);
  flame->palette->setColor(53,95,114,53);
  flame->palette->setColor(54,103,121,52);
  flame->palette->setColor(55,112,128,52);
  flame->palette->setColor(56,120,135,51);
  flame->palette->setColor(57,129,143,50);
  flame->palette->setColor(58,137,150,50);
  flame->palette->setColor(59,145,157,49);
  flame->palette->setColor(60,151,162,51);
  flame->palette->setColor(61,146,155,60);
  flame->palette->setColor(62,141,148,69);
  flame->palette->setColor(63,136,141,79);
  flame->palette->setColor(64,132,133,88);
  flame->palette->setColor(65,127,126,97);
  flame->palette->setColor(66,122,119,107);
  flame->palette->setColor(67,117,112,116);
  flame->palette->setColor(68,112,105,125);
  flame->palette->setColor(69,107,98,135);
  flame->palette->setColor(70,102,91,144);
  flame->palette->setColor(71,98,84,153);
  flame->palette->setColor(72,93,77,163);
  flame->palette->setColor(73,88,70,172);
  flame->palette->setColor(74,83,63,181);
  flame->palette->setColor(75,78,56,191);
  flame->palette->setColor(76,73,49,200);
  flame->palette->setColor(77,69,44,207);
  flame->palette->setColor(78,66,52,197);
  flame->palette->setColor(79,63,60,187);
  flame->palette->setColor(80,60,68,178);
  flame->palette->setColor(81,57,76,168);
  flame->palette->setColor(82,54,84,158);
  flame->palette->setColor(83,51,92,148);
  flame->palette->setColor(84,48,99,139);
  flame->palette->setColor(85,45,107,129);
  flame->palette->setColor(86,42,115,119);
  flame->palette->setColor(87,39,123,109);
  flame->palette->setColor(88,36,131,100);
  flame->palette->setColor(89,33,139,90);
  flame->palette->setColor(90,31,147,80);
  flame->palette->setColor(91,28,155,71);
  flame->palette->setColor(92,25,163,61);
  flame->palette->setColor(93,22,171,51);
  flame->palette->setColor(94,20,177,42);
  flame->palette->setColor(95,30,169,47);
  flame->palette->setColor(96,41,161,51);
  flame->palette->setColor(97,52,152,56);
  flame->palette->setColor(98,63,144,61);
  flame->palette->setColor(99,73,136,65);
  flame->palette->setColor(100,84,127,70);
  flame->palette->setColor(101,95,119,74);
  flame->palette->setColor(102,105,110,79);
  flame->palette->setColor(103,116,102,83);
  flame->palette->setColor(104,127,94,88);
  flame->palette->setColor(105,138,85,93);
  flame->palette->setColor(106,148,77,97);
  flame->palette->setColor(107,159,69,102);
  flame->palette->setColor(108,170,60,106);
  flame->palette->setColor(109,181,52,111);
  flame->palette->setColor(110,191,43,115);
  flame->palette->setColor(111,243,138,225);
  flame->palette->setColor(112,238,142,219);
  flame->palette->setColor(113,234,147,213);
  flame->palette->setColor(114,229,151,207);
  flame->palette->setColor(115,224,156,201);
  flame->palette->setColor(116,220,160,195);
  flame->palette->setColor(117,215,165,189);
  flame->palette->setColor(118,211,169,183);
  flame->palette->setColor(119,206,174,177);
  flame->palette->setColor(120,201,178,171);
  flame->palette->setColor(121,197,183,165);
  flame->palette->setColor(122,192,187,159);
  flame->palette->setColor(123,187,191,153);
  flame->palette->setColor(124,183,196,147);
  flame->palette->setColor(125,178,200,141);
  flame->palette->setColor(126,174,205,135);
  flame->palette->setColor(127,169,209,129);
  flame->palette->setColor(128,164,214,123);
  flame->palette->setColor(129,164,206,128);
  flame->palette->setColor(130,163,197,132);
  flame->palette->setColor(131,163,188,137);
  flame->palette->setColor(132,162,179,142);
  flame->palette->setColor(133,162,170,147);
  flame->palette->setColor(134,162,161,152);
  flame->palette->setColor(135,161,152,157);
  flame->palette->setColor(136,161,143,162);
  flame->palette->setColor(137,160,134,166);
  flame->palette->setColor(138,160,125,171);
  flame->palette->setColor(139,160,116,176);
  flame->palette->setColor(140,159,107,181);
  flame->palette->setColor(141,159,98,186);
  flame->palette->setColor(142,158,89,191);
  flame->palette->setColor(143,158,80,196);
  flame->palette->setColor(144,157,71,200);
  flame->palette->setColor(145,157,62,205);
  flame->palette->setColor(146,160,65,203);
  flame->palette->setColor(147,164,70,200);
  flame->palette->setColor(148,167,75,197);
  flame->palette->setColor(149,171,80,194);
  flame->palette->setColor(150,174,86,191);
  flame->palette->setColor(151,178,91,188);
  flame->palette->setColor(152,181,96,185);
  flame->palette->setColor(153,185,101,182);
  flame->palette->setColor(154,188,106,178);
  flame->palette->setColor(155,192,111,175);
  flame->palette->setColor(156,195,116,172);
  flame->palette->setColor(157,199,121,169);
  flame->palette->setColor(158,202,126,166);
  flame->palette->setColor(159,206,131,163);
  flame->palette->setColor(160,209,136,160);
  flame->palette->setColor(161,213,141,157);
  flame->palette->setColor(162,216,146,154);
  flame->palette->setColor(163,218,152,146);
  flame->palette->setColor(164,218,158,137);
  flame->palette->setColor(165,219,165,129);
  flame->palette->setColor(166,220,171,120);
  flame->palette->setColor(167,221,177,111);
  flame->palette->setColor(168,222,184,103);
  flame->palette->setColor(169,223,190,94);
  flame->palette->setColor(170,223,196,85);
  flame->palette->setColor(171,224,203,77);
  flame->palette->setColor(172,225,209,68);
  flame->palette->setColor(173,226,215,59);
  flame->palette->setColor(174,227,222,51);
  flame->palette->setColor(175,228,228,42);
  flame->palette->setColor(176,228,234,33);
  flame->palette->setColor(177,229,241,25);
  flame->palette->setColor(178,230,247,16);
  flame->palette->setColor(179,231,253,7);
  flame->palette->setColor(180,227,245,10);
  flame->palette->setColor(181,221,232,17);
  flame->palette->setColor(182,215,218,24);
  flame->palette->setColor(183,208,205,31);
  flame->palette->setColor(184,202,192,38);
  flame->palette->setColor(185,196,178,45);
  flame->palette->setColor(186,190,165,52);
  flame->palette->setColor(187,184,152,58);
  flame->palette->setColor(188,178,138,65);
  flame->palette->setColor(189,172,125,72);
  flame->palette->setColor(190,166,112,79);
  flame->palette->setColor(191,160,98,86);
  flame->palette->setColor(192,154,85,93);
  flame->palette->setColor(193,148,72,100);
  flame->palette->setColor(194,142,58,107);
  flame->palette->setColor(195,136,45,114);
  flame->palette->setColor(196,130,31,121);
  flame->palette->setColor(197,130,30,118);
  flame->palette->setColor(198,132,35,111);
  flame->palette->setColor(199,135,40,104);
  flame->palette->setColor(200,138,45,97);
  flame->palette->setColor(201,141,50,90);
  flame->palette->setColor(202,143,55,83);
  flame->palette->setColor(203,146,60,76);
  flame->palette->setColor(204,149,65,69);
  flame->palette->setColor(205,151,70,62);
  flame->palette->setColor(206,154,75,55);
  flame->palette->setColor(207,157,80,48);
  flame->palette->setColor(208,159,84,41);
  flame->palette->setColor(209,162,89,34);
  flame->palette->setColor(210,165,94,27);
  flame->palette->setColor(211,168,99,20);
  flame->palette->setColor(212,170,104,13);
  flame->palette->setColor(213,173,109,6);
  flame->palette->setColor(214,173,113,12);
  flame->palette->setColor(215,171,116,26);
  flame->palette->setColor(216,170,119,40);
  flame->palette->setColor(217,168,122,54);
  flame->palette->setColor(218,166,125,68);
  flame->palette->setColor(219,164,128,82);
  flame->palette->setColor(220,163,131,97);
  flame->palette->setColor(221,161,135,111);
  flame->palette->setColor(222,159,138,125);
  flame->palette->setColor(223,158,141,139);
  flame->palette->setColor(224,156,144,153);
  flame->palette->setColor(225,154,147,167);
  flame->palette->setColor(226,153,150,182);
  flame->palette->setColor(227,151,153,196);
  flame->palette->setColor(228,149,156,210);
  flame->palette->setColor(229,147,159,224);
  flame->palette->setColor(230,146,163,238);
  flame->palette->setColor(231,148,166,238);
  flame->palette->setColor(232,154,169,225);
  flame->palette->setColor(233,160,172,212);
  flame->palette->setColor(234,166,175,199);
  flame->palette->setColor(235,172,178,186);
  flame->palette->setColor(236,177,181,173);
  flame->palette->setColor(237,183,184,160);
  flame->palette->setColor(238,189,187,147);
  flame->palette->setColor(239,195,191,134);
  flame->palette->setColor(240,201,194,121);
  flame->palette->setColor(241,207,197,108);
  flame->palette->setColor(242,213,200,95);
  flame->palette->setColor(243,218,203,82);
  flame->palette->setColor(244,224,206,69);
  flame->palette->setColor(245,230,209,56);
  flame->palette->setColor(246,236,212,43);
  flame->palette->setColor(247,242,215,30);
  flame->palette->setColor(248,240,214,22);
  flame->palette->setColor(249,230,207,21);
  flame->palette->setColor(250,220,200,20);
  flame->palette->setColor(251,210,193,19);
  flame->palette->setColor(252,200,186,18);
  flame->palette->setColor(253,190,179,16);
  flame->palette->setColor(254,179,172,15);
  flame->palette->setColor(255,169,165,14);

  flame->xFormCount=5;
  hostMalloc((void**)&flame->xForms, flame->xFormCount*sizeof(XForm*));
  // xForm1
  hostMalloc((void**)&flame->xForms[0], sizeof(XForm));
  flame->xForms[0]->init();
  flame->xForms[0]->weight=13.76f;
  flame->xForms[0]->color=0.83356f;
  flame->xForms[0]->colorSymmetry=1.0f;
  flame->xForms[0]->coeff00=0.0f;
  flame->xForms[0]->coeff01=1.0f;
  flame->xForms[0]->coeff10=-1.0f;
  flame->xForms[0]->coeff11=0.0f;
  flame->xForms[0]->coeff20=1.0f;
  flame->xForms[0]->coeff21=0.0f;
  flame->xForms[0]->postCoeff00=1.0f;
  flame->xForms[0]->postCoeff01=0.0f;
  flame->xForms[0]->postCoeff10=0.0f;
  flame->xForms[0]->postCoeff11=1.0f;
  flame->xForms[0]->postCoeff20=0.0f;
  flame->xForms[0]->postCoeff21=0.0f;
  flame->xForms[0]->addVariation(variationFactory->newInstance("spherical3D") , 1.0f);
  // xForm2
  hostMalloc((void**)&flame->xForms[1], sizeof(XForm));
  flame->xForms[1]->init();
  flame->xForms[1]->weight=9.32f;
  flame->xForms[1]->color=0.56512f;
  flame->xForms[1]->colorSymmetry=1.0f;
  flame->xForms[1]->coeff00=0.0f;
  flame->xForms[1]->coeff01=1.0f;
  flame->xForms[1]->coeff10=-1.0f;
  flame->xForms[1]->coeff11=0.0f;
  flame->xForms[1]->coeff20=0.0f;
  flame->xForms[1]->coeff21=0.0f;
  flame->xForms[1]->postCoeff00=1.0f;
  flame->xForms[1]->postCoeff01=0.0f;
  flame->xForms[1]->postCoeff10=0.0f;
  flame->xForms[1]->postCoeff11=1.0f;
  flame->xForms[1]->postCoeff20=0.0f;
  flame->xForms[1]->postCoeff21=0.0f;
  flame->xForms[1]->addVariation(variationFactory->newInstance("spherical3D") , 1.0f);
  // xForm3
  hostMalloc((void**)&flame->xForms[2], sizeof(XForm));
  flame->xForms[2]->init();
  flame->xForms[2]->weight=0.36664f;
  flame->xForms[2]->color=0.31822f;
  flame->xForms[2]->colorSymmetry=0.0f;
  flame->xForms[2]->coeff00=0.0f;
  flame->xForms[2]->coeff01=-1.0f;
  flame->xForms[2]->coeff10=1.0f;
  flame->xForms[2]->coeff11=0.0f;
  flame->xForms[2]->coeff20=3.0f;
  flame->xForms[2]->coeff21=0.0f;
  flame->xForms[2]->postCoeff00=1.0f;
  flame->xForms[2]->postCoeff01=0.0f;
  flame->xForms[2]->postCoeff10=0.0f;
  flame->xForms[2]->postCoeff11=1.0f;
  flame->xForms[2]->postCoeff20=0.0f;
  flame->xForms[2]->postCoeff21=0.0f;
  flame->xForms[2]->addVariation(variationFactory->newInstance("linear3D") , 1.0f);
  // xForm4
  hostMalloc((void**)&flame->xForms[3], sizeof(XForm));
  flame->xForms[3]->init();
  flame->xForms[3]->weight=0.33031f;
  flame->xForms[3]->color=0.34176f;
  flame->xForms[3]->colorSymmetry=0.0f;
  flame->xForms[3]->coeff00=0.0f;
  flame->xForms[3]->coeff01=-1.0f;
  flame->xForms[3]->coeff10=1.0f;
  flame->xForms[3]->coeff11=0.0f;
  flame->xForms[3]->coeff20=-2.0f;
  flame->xForms[3]->coeff21=0.0f;
  flame->xForms[3]->postCoeff00=1.0f;
  flame->xForms[3]->postCoeff01=0.0f;
  flame->xForms[3]->postCoeff10=0.0f;
  flame->xForms[3]->postCoeff11=1.0f;
  flame->xForms[3]->postCoeff20=0.0f;
  flame->xForms[3]->postCoeff21=0.0f;
  flame->xForms[3]->addVariation(variationFactory->newInstance("linear3D") , 1.0f);
  // xForm5
  hostMalloc((void**)&flame->xForms[4], sizeof(XForm));
  flame->xForms[4]->init();
  flame->xForms[4]->weight=0.58371f;
  flame->xForms[4]->color=0.59693f;
  flame->xForms[4]->colorSymmetry=0.0f;
  flame->xForms[4]->coeff00=0.24828f;
  flame->xForms[4]->coeff01=-0.24739f;
  flame->xForms[4]->coeff10=0.24739f;
  flame->xForms[4]->coeff11=0.24828f;
  flame->xForms[4]->coeff20=0.22167f;
  flame->xForms[4]->coeff21=-0.06921f;
  flame->xForms[4]->postCoeff00=1.0f;
  flame->xForms[4]->postCoeff01=0.0f;
  flame->xForms[4]->postCoeff10=0.0f;
  flame->xForms[4]->postCoeff11=1.0f;
  flame->xForms[4]->postCoeff20=0.0f;
  flame->xForms[4]->postCoeff21=0.0f;
  flame->xForms[4]->addVariation(variationFactory->newInstance("ztranslate") , -4.03f);
  flame->xForms[4]->addVariation(variationFactory->newInstance("spiral") , 1.0f);

  return flame;
}
#endif


#endif // __JWF_EXAMPLE_FLAMES_H__
